#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# Form implementation generated from reading ui file 'MainCoffee.ui'
#
# Created by: PyQt5 UI code generator 5.11.3
#
# WARNING! All changes made in this file will be lost!
from PyQt5 import QtCore, QtGui, QtWidgets
from PyQt5.QtCore import QTimer, Qt, QSize
import RPi.GPIO as GPIO
import time
#import datetime
from datetime import datetime
import requests
import os
import shutil
import json
import pyqrcode
from pyqrcode import QRCode
from io import BytesIO
import subprocess
from urllib.request import urlopen
import urllib.request
import Api
import pyspeedtest
import socket

def setRelay(pin):
    GPIO.setmode(GPIO.BCM)
    GPIO.setwarnings(False)
    GPIO.cleanup()
    GPIO.setup(pin, GPIO.OUT)
    GPIO.output(pin, GPIO.HIGH)
    
def setPin(pin1, pin2, pin3, pin4, pin5):
    GPIO.setmode(GPIO.BCM)
    GPIO.setwarnings(False)
    GPIO.cleanup()
    GPIO.setup(pin1, GPIO.OUT)
    GPIO.output(pin1, GPIO.HIGH)
    GPIO.setup(pin2, GPIO.OUT)
    GPIO.output(pin2, GPIO.HIGH)
    GPIO.setup(pin3, GPIO.OUT)
    GPIO.output(pin3, GPIO.HIGH)
    GPIO.setup(pin4, GPIO.OUT)
    GPIO.output(pin4, GPIO.HIGH)
    GPIO.setup(pin5, GPIO.OUT)
    GPIO.output(pin5, GPIO.HIGH)
    
def ConnectRelay(pin):
    GPIO.output(pin, GPIO.LOW)

def DisconnectRelay(pin):
    GPIO.output(pin, GPIO.HIGH)

def CheckFile(file):
    return os.path.isfile(file)

class Ui_Dialog(object):
    def setupUi(self, Dialog):
        Dialog.setObjectName("OmegaSanitizer")
        Dialog.resize(1024, 600)
        Dialog.setWindowFlags(QtCore.Qt.FramelessWindowHint)
        Dialog.setWindowState(QtCore.Qt.WindowFullScreen)
        Dialog.setCursor(QtCore.Qt.BlankCursor)
        Dialog.setWindowIcon(QtGui.QIcon("/home/pi/Documents/OmegaSanitizer/Img/appicon.png"))
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Preferred, QtWidgets.QSizePolicy.Preferred)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(Dialog.sizePolicy().hasHeightForWidth())
        Dialog.setSizePolicy(sizePolicy)
        Dialog.setStyleSheet("background-color: rgb(0, 0, 0);")
        #update image
        self.imageBG=""
        self.imageBtn1=""
        self.imageBtn2=""
        self.imageBtn3=""
        self.lblBG = QtWidgets.QLabel(Dialog)
        self.lblBG.setGeometry(QtCore.QRect(0, 0, 1024, 600))
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBG))
        font30 = QtGui.QFont()
        font30.setFamily("Quicksand Medium")
        font30.setPointSize(30)
        font40 = QtGui.QFont()
        font40.setFamily("Quicksand Medium")
        font40.setPointSize(40)
        font50 = QtGui.QFont()
        font50.setFamily("Quicksand Medium")
        font50.setPointSize(50)
        fontclwhite = "color: rgb(255, 255, 255);"
        fontclblack = "color: rgb(0, 0, 0)"
        fontclnew = "color: rgb(39,39,39)"
        clbutton = "rgb(95,185,222)"
        #frame Header
        self.frameHeader = QtWidgets.QFrame(Dialog)
        self.frameHeader.setGeometry(QtCore.QRect(0, 0, 1024, 160))
        self.frameHeader.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.frameHeader.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameHeader.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameHeader.setObjectName("frameHeader")
        self.LogoBtn = QtWidgets.QPushButton(self.frameHeader)
        self.LogoBtn.setGeometry(QtCore.QRect(0, 0, 275, 75))
        self.LogoBtn.setObjectName("LogoBtn")
        self.LogoBtn.clicked.connect(self.LogoClicked)
        self.LogoBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaSanitizer/Img/Logo.png); border : none")
        self.InternetBtn = QtWidgets.QPushButton(self.frameHeader)
        self.InternetBtn.setGeometry(QtCore.QRect(950, 30, 30, 30))
        self.InternetBtn.setObjectName("InternetBtn")
        self.InternetBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}")
        self.InternetBtn.clicked.connect(self.InternetBtnClicked)
        self.IsInternetClicked=False
        self.lblVersion=QtWidgets.QLabel(self.frameHeader)
        self.lblVersion.setGeometry(QtCore.QRect(280, 0, 150, 20))
        font = QtGui.QFont("Quicksand Medium")
        font.setPointSize(15)
        self.lblVersion.setFont(font)
        self.lblVersion.setText("V.")
        self.lblVersion.setStyleSheet(fontclnew)
        self.lblVersion.setAlignment(QtCore.Qt.AlignLeft)
        self.lblVersion.setObjectName("lblVersion")
        self.lblVersion.show()
        self.lblExceptionWarning=QtWidgets.QLabel(self.frameHeader)
        self.lblExceptionWarning.setGeometry(QtCore.QRect(660, 0, 250, 70))
        self.lblExceptionWarning.setFont(font)
        self.lblExceptionWarning.setText("Mohon Tunggu..\nMencari Koneksi")
        self.lblExceptionWarning.setStyleSheet(fontclnew+"; background-color:red;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}")
        self.lblExceptionWarning.setAlignment(QtCore.Qt.AlignRight)
        self.lblExceptionWarning.setObjectName("lblExceptionWarning")
        self.lblExceptionWarning.hide()        
        self.lblWaitingPayment=QtWidgets.QLabel(self.frameHeader)
        self.lblWaitingPayment.setGeometry(QtCore.QRect(387, 0, 250, 70))
        self.lblWaitingPayment.setFont(font)
        self.lblWaitingPayment.setText("Menunggu Pembayaran")
        self.lblWaitingPayment.setStyleSheet(fontclnew+"; background-color:"+clbutton+";"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}")
        self.lblWaitingPayment.setAlignment(QtCore.Qt.AlignCenter)
        self.lblWaitingPayment.setObjectName("lblWaitingPayment")
        self.lblWaitingPayment.hide()
        self.lblInternetSpeed = QtWidgets.QLabel(self.frameHeader)
        self.lblInternetSpeed.setGeometry(QtCore.QRect(865, 0, 100, 20))
        font = QtGui.QFont("Quicksand Medium")
        font.setPointSize(15)
        self.lblInternetSpeed.setFont(font)
        self.lblInternetSpeed.setText("..ms")
        self.lblInternetSpeed.setStyleSheet(fontclnew)
        self.lblInternetSpeed.setAlignment(QtCore.Qt.AlignRight)
        self.lblInternetSpeed.setObjectName("lblInternetSpeed")
        self.lblInternetSpeed.hide()
        self.arrInternetSpeed=[]
        self.lblInternetPercent = QtWidgets.QLabel(self.frameHeader)
        self.lblInternetPercent.setGeometry(QtCore.QRect(965, 0, 60, 20))
        font = QtGui.QFont("Quicksand Medium")
        font.setPointSize(15)
        self.lblInternetPercent.setFont(font)
        self.lblInternetPercent.setText("...%")
        self.lblInternetPercent.setStyleSheet(fontclnew)
        self.lblInternetPercent.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInternetPercent.setObjectName("lblInternetPercent")
        self.lblInternetPercent.show()
        self.lblMenuSelected = QtWidgets.QLabel(self.frameHeader)
        self.lblMenuSelected.setGeometry(QtCore.QRect(5, 75, 1014, 40))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(30)
        self.lblMenuSelected.setFont(font)
        self.lblMenuSelected.setText("")
        self.lblMenuSelected.setStyleSheet(fontclnew)
        self.lblMenuSelected.setAlignment(QtCore.Qt.AlignCenter)
        self.lblMenuSelected.setObjectName("lblMenuSelected")
        self.lblMenuSelected.hide()
        self.lblMenuPrice = QtWidgets.QLabel(self.frameHeader)
        self.lblMenuPrice.setGeometry(QtCore.QRect(5, 125, 1014, 35))
        font = QtGui.QFont()
        font.setPointSize(30)
        self.lblMenuPrice.setFont(font)
        self.lblMenuPrice.setText("")
        self.lblMenuPrice.setStyleSheet(fontclnew)
        self.lblMenuPrice.setAlignment(QtCore.Qt.AlignCenter)
        self.lblMenuPrice.setObjectName("lblMenuPrice")
        self.lblMenuPrice.hide()
        #frame Menu
        self.frameMenu = QtWidgets.QFrame(Dialog)
        self.frameMenu.setGeometry(QtCore.QRect(40, 80, 944, 520))
        self.frameMenu.setStyleSheet("background-color: rgba(255, 255, 255, 150); border : none")
        self.frameMenu.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameMenu.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameMenu.setObjectName("frameMenu")
        self.Menu1Btn = QtWidgets.QPushButton(self.frameMenu)
        self.Menu1Btn.setGeometry(QtCore.QRect(78, 390, 256, 59))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(24)
        self.Menu1Btn.setFont(font)
        self.Menu1Btn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.Menu1Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.Menu1Btn.setObjectName("Menu1Btn")
        self.Menu1Btn.clicked.connect(self.MenuClick)
        self.Menu1ImgBtn = QtWidgets.QPushButton(self.frameMenu)
        self.Menu1ImgBtn.setGeometry(QtCore.QRect(78, 180, 256, 207))
        self.Menu1ImgBtn.setStyleSheet("border-style: outset; border-width: 5px; border-radius: 0px;"
                                        "border-color: beige;padding: 6px;}")
        self.Menu1ImgBtn.setIcon(QtGui.QIcon(self.imageBtn1))
        self.Menu1ImgBtn.setIconSize(QSize(251,251))
        self.Menu1ImgBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.Menu1ImgBtn.setObjectName("Menu1ImgBtn")
        self.Menu1ImgBtn.clicked.connect(self.MenuClick)
        self.lblMenu1Btn = QtWidgets.QLabel(self.Menu1ImgBtn)
        self.lblMenu1Btn.setGeometry(QtCore.QRect(0, 0, 256, 207))
        self.lblMenu1Btn.setStyleSheet("color: blue;")
        self.lblMenu1Btn.setAlignment(QtCore.Qt.AlignCenter)
        self.lblMenu1Btn.setObjectName("lblMenu1Btn")
        self.lblMenu1Btn.raise_()
        self.lblMenu1Btn.hide()
        self.Menu2Btn = QtWidgets.QPushButton(self.frameMenu)
        self.Menu2Btn.setGeometry(QtCore.QRect(344, 390, 256, 59))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(24)
        self.Menu2Btn.setFont(font)
        self.Menu2Btn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.Menu2Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.Menu2Btn.setObjectName("Menu2Btn")
        self.Menu2Btn.clicked.connect(self.Menu2Click)
        self.Menu2ImgBtn = QtWidgets.QPushButton(self.frameMenu)
        self.Menu2ImgBtn.setGeometry(QtCore.QRect(344, 180, 256, 207))
        self.Menu2ImgBtn.setStyleSheet("border-style: outset; border-width: 5px; border-radius: 0px;"
                                        "border-color: beige;padding: 6px;}")
        self.Menu2ImgBtn.setIcon(QtGui.QIcon(self.imageBtn2))
        self.Menu2ImgBtn.setIconSize(QSize(251,251))
        self.Menu2ImgBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.Menu2ImgBtn.setObjectName("Menu2ImgBtn")
        self.Menu2ImgBtn.clicked.connect(self.Menu2Click)
        self.lblMenu2Btn = QtWidgets.QLabel(self.Menu2ImgBtn)
        self.lblMenu2Btn.setGeometry(QtCore.QRect(0, 0, 256, 207))
        self.lblMenu2Btn.setStyleSheet("color: blue;")
        self.lblMenu2Btn.setAlignment(QtCore.Qt.AlignCenter)
        self.lblMenu2Btn.setObjectName("lblMenu2Btn")
        self.lblMenu2Btn.raise_()
        self.lblMenu2Btn.hide()
        self.Menu3Btn = QtWidgets.QPushButton(self.frameMenu)
        self.Menu3Btn.setGeometry(QtCore.QRect(610, 390, 256, 59))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(24)
        self.Menu3Btn.setFont(font)
        self.Menu3Btn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.Menu3Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.Menu3Btn.setObjectName("Menu3Btn")
        self.Menu3Btn.clicked.connect(self.Menu3Click)
        self.Menu3ImgBtn = QtWidgets.QPushButton(self.frameMenu)
        self.Menu3ImgBtn.setGeometry(QtCore.QRect(610, 180, 256, 207))
        self.Menu3ImgBtn.setStyleSheet("border-style: outset; border-width: 5px; border-radius: 0px;"
                                        "border-color: beige;padding: 6px;}")
        self.Menu3ImgBtn.setIcon(QtGui.QIcon(self.imageBtn3))
        self.Menu3ImgBtn.setIconSize(QSize(251,251))
        self.Menu3ImgBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.Menu3ImgBtn.setObjectName("Menu3ImgBtn")
        self.Menu3ImgBtn.clicked.connect(self.Menu3Click)
        self.lblMenu3Btn = QtWidgets.QLabel(self.Menu3ImgBtn)
        self.lblMenu3Btn.setGeometry(QtCore.QRect(0, 0, 256, 207))
        self.lblMenu3Btn.setStyleSheet("color: blue;")
        self.lblMenu3Btn.setAlignment(QtCore.Qt.AlignCenter)
        self.lblMenu3Btn.setObjectName("lblMenu3Btn")
        self.lblMenu3Btn.raise_()
        self.lblMenu3Btn.hide()
        self.lblPrice1 = QtWidgets.QLabel(self.frameMenu)
        self.lblPrice1.setGeometry(QtCore.QRect(78,100, 256, 59))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(24)
        self.lblPrice1.setFont(font)
        self.lblPrice1.setStyleSheet("background-color: "+clbutton+"; "+fontclnew+";"
                                "border-style: outset; border-width: 2px; border-radius: 10px;"
                                "border-color: beige;padding: 6px;}")
        self.lblPrice1.setAlignment(QtCore.Qt.AlignCenter)
        self.lblPrice1.setObjectName("lblPrice1")
        self.lblPrice1.setText("Rp -")
        self.lblPrice2 = QtWidgets.QLabel(self.frameMenu)
        self.lblPrice2.setGeometry(QtCore.QRect(344, 100, 256, 59))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(24)
        self.lblPrice2.setFont(font)
        self.lblPrice2.setStyleSheet("background-color: "+clbutton+"; "+fontclnew+";"
                                "border-style: outset; border-width: 2px; border-radius: 10px;"
                                "border-color: beige;padding: 6px;}")
        self.lblPrice2.setAlignment(QtCore.Qt.AlignCenter)
        self.lblPrice2.setObjectName("lblPrice2")
        self.lblPrice2.setText("Rp -")
        self.lblPrice3 = QtWidgets.QLabel(self.frameMenu)
        self.lblPrice3.setGeometry(QtCore.QRect(610, 100, 256, 59))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(24)
        self.lblPrice3.setFont(font)
        self.lblPrice3.setStyleSheet("background-color: "+clbutton+"; "+fontclnew+";"
                                "border-style: outset; border-width: 2px; border-radius: 10px;"
                                "border-color: beige;padding: 6px;}")
        self.lblPrice3.setAlignment(QtCore.Qt.AlignCenter)
        self.lblPrice3.setObjectName("lblPrice3")
        self.lblPrice3.setText("Rp -")
        self.lblQty = QtWidgets.QLabel(self.frameMenu)
        self.lblQty.setGeometry(QtCore.QRect(358, 10, 230, 79))
        font = QtGui.QFont()
        font.setPointSize(48)
        font.setBold(True)
        font.setWeight(75)
        self.lblQty.setFont(font)
        self.lblQty.setStyleSheet("background-color: "+clbutton+"; "+fontclnew+";"
                                "border-style: outset; border-width: 2px; border-radius: 10px;"
                                "border-color: beige;padding: 6px;}")
        self.lblQty.setAlignment(QtCore.Qt.AlignCenter)
        self.lblQty.setObjectName("lblQty")
        self.AddQtyBtn = QtWidgets.QPushButton(self.frameMenu)
        self.AddQtyBtn.setGeometry(QtCore.QRect(597, 10, 115, 79))
        font = QtGui.QFont()
        font.setPointSize(36)
        self.AddQtyBtn.setFont(font)
        self.AddQtyBtn.setStyleSheet("background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}")
        self.AddQtyBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.AddQtyBtn.setObjectName("AddQtyBtn")
        self.AddQtyBtn.clicked.connect(self.AddQtyClicked)
        self.DecQtyBtn = QtWidgets.QPushButton(self.frameMenu)
        self.DecQtyBtn.setGeometry(QtCore.QRect(238, 10, 115, 79))
        font = QtGui.QFont()
        font.setPointSize(36)
        self.DecQtyBtn.setFont(font)
        self.DecQtyBtn.setStyleSheet("background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}")
        self.DecQtyBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.DecQtyBtn.setObjectName("DecQtyBtn")
        self.DecQtyBtn.clicked.connect(self.DecQtyClicked)
        #frame Login
        self.frameLogin = QtWidgets.QFrame(Dialog)
        tmpfont = QtGui.QFont()
        tmpfont.setFamily("Quicksand Medium")
        tmpfont.setPointSize(12)
        self.frameLogin.setGeometry(QtCore.QRect(0, 0, 1024, 290))
        self.frameLogin.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameLogin.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameLogin.setObjectName("frameLogin")
        self.frameLogin.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameLogin.hide()
        self.widget = QtWidgets.QWidget(self.frameLogin)
        self.widget.setGeometry(QtCore.QRect(222, 60, 550, 111))
        self.widget.setObjectName("widget")
        self.gridLayout = QtWidgets.QGridLayout(self.widget)
        self.gridLayout.setContentsMargins(0, 0, 0, 0)
        self.gridLayout.setObjectName("gridLayout")
        self.lblUserID = QtWidgets.QLabel(self.widget)
        self.lblUserID.setFont(tmpfont)
        self.lblUserID.setObjectName("lblUserID")
        self.gridLayout.addWidget(self.lblUserID, 0, 0, 1, 1)
        self.lineUserID = QtWidgets.QLineEdit(self.widget)
        self.lineUserID.setFont(tmpfont)
        self.lineUserID.setObjectName("lineUserID")
        self.lineUserID.returnPressed.connect(self.LoginClicked)
        self.gridLayout.addWidget(self.lineUserID, 0, 1, 1, 1)
        self.lblPassword = QtWidgets.QLabel(self.widget)
        self.lblPassword.setFont(tmpfont)
        self.lblPassword.setObjectName("lblPassword")
        self.gridLayout.addWidget(self.lblPassword, 1, 0, 1, 1)
        self.linePassword = QtWidgets.QLineEdit(self.widget)
        self.linePassword.setFont(tmpfont)
        self.linePassword.setObjectName("linePassword")
        self.linePassword.setEchoMode(QtWidgets.QLineEdit.Password)
        self.linePassword.returnPressed.connect(self.LoginClicked)
        self.gridLayout.addWidget(self.linePassword, 1, 1, 1, 1)
        self.widget1 = QtWidgets.QWidget(self.frameLogin)
        self.widget1.setGeometry(QtCore.QRect(572, 210, 200, 30))
        self.widget1.setObjectName("widget1")
        self.gridLayout_2 = QtWidgets.QGridLayout(self.widget1)
        self.gridLayout_2.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_2.setObjectName("gridLayout_2")
        self.CancelLoginBtn = QtWidgets.QPushButton(self.widget1)
        self.CancelLoginBtn.setFont(tmpfont)
        self.CancelLoginBtn.setObjectName("CancelLoginBtn")
        self.CancelLoginBtn.clicked.connect(self.LogoClicked)
        self.CancelLoginBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayout_2.addWidget(self.CancelLoginBtn, 0, 0, 1, 1)
        self.LoginBtn = QtWidgets.QPushButton(self.widget1)
        self.LoginBtn.setFont(tmpfont)
        self.LoginBtn.setObjectName("LoginBtn")
        self.LoginBtn.clicked.connect(self.LoginClicked) 
        self.LoginBtn.setFocusPolicy(QtCore.Qt.NoFocus)       
        self.gridLayout_2.addWidget(self.LoginBtn, 0, 1, 1, 1)
        #frame Keyboard
        self.frameKeyboard = QtWidgets.QFrame(Dialog)
        self.frameKeyboard.setGeometry(QtCore.QRect(0, 290, 1024, 310))
        self.frameKeyboard.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameKeyboard.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameKeyboard.setObjectName("frameKeyboard")
        self.frameKeyboard.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameKeyboard.hide()
        self.buttons=["`", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0", "-", "=", "<-",
                 "Tab", "q", "w", "e", "r", "t", "y", "u", "i", "o", "p", "[", "]", "Ent",
                 "Caps", "a", "s", "d", "f", "g", "h", "j", "k", "l", ";", ":", "'", "Ctrl",
                 "Shft", "<", "z", "x", "c", "v", "b", "n", "m", ".", ",", "/", ">", "Alt",
                 "Space"]
        self.buttons2=["~", "!", "@", "#", "$", "%", "^", "&", "*", "(", ")", "_", "+", "<-",
                 "Tab", "Q", "W", "E", "R", "T", "Y", "U", "I", "O", "P", "{", "}", "Ent",
                 "Caps", "A", "S", "D", "F", "G", "H", "J", "K", "L", ";", ":", '"', "Ctrl",
                 "Shft", "<", "Z", "X", "C", "V", "B", "N", "M", ".", ",", "?", ">", "Alt",
                 "Space"]
        self.btn=[]
        for x in range(len(self.buttons)) :
            self.btn.append(x)
            self.btn[x]=QtWidgets.QPushButton(self.frameKeyboard)
            txtKey = self.buttons[x]
            self.btn[x].setText(txtKey)
            if txtKey=="Space":
                self.btn[x].setGeometry(QtCore.QRect(87+(x%14*60), 7+(x//14*60), 835, 55))            
            else :
                self.btn[x].setGeometry(QtCore.QRect(87+(x%14*60), 7+(x//14*60), 55, 55))
            self.btn[x].setFocusPolicy(QtCore.Qt.NoFocus)
            self.btn[x].clicked.connect(lambda checked, a=x : self.KeyboardClicked(a))
        self.CapsOn=False
        self.ShiftOn=False
        self.CtrlOn=False
        #frame Setting
        self.frameSetting = QtWidgets.QFrame(Dialog)
        self.frameSetting.setGeometry(QtCore.QRect(0, 0, 1024, 290))
        self.frameSetting.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameSetting.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameSetting.setObjectName("frameSetting")
        self.frameSetting.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameSetting.hide()
        self.widget2 = QtWidgets.QWidget(self.frameSetting)
        self.widget2.setGeometry(QtCore.QRect(20, 21, 700, 141))
        self.widget2.setObjectName("widget2")
        self.gridLayout_3 = QtWidgets.QGridLayout(self.widget2)
        self.gridLayout_3.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_3.setObjectName("gridLayout_3")
        self.lblStaff = QtWidgets.QLabel(self.widget2)
        self.lblStaff.setObjectName("lblStaff")
        self.gridLayout_3.addWidget(self.lblStaff, 0, 0, 1, 1)
        self.lineStaff = QtWidgets.QLineEdit(self.widget2)
        self.lineStaff.setObjectName("lineStaff")
        self.lineStaff.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineStaff, 0, 1, 1, 2)
        self.lblSettingTime = QtWidgets.QLabel(self.widget2)
        self.lblSettingTime.setObjectName("lblStaff")
        self.gridLayout_3.addWidget(self.lblSettingTime, 0, 3, 1, 1)
        self.lblMenu1 = QtWidgets.QLabel(self.widget2)
        self.lblMenu1.setObjectName("lblMenu1")
        self.gridLayout_3.addWidget(self.lblMenu1, 1, 0, 1, 1)
        self.lineKode1 = QtWidgets.QLineEdit(self.widget2)
        self.lineKode1.setObjectName("lineKode1")
        self.lineKode1.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineKode1, 1, 1, 1, 1)
        self.lineTime1 = QtWidgets.QLineEdit(self.widget2)
        self.lineTime1.setObjectName("lineTime1")
        self.lineTime1.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineTime1, 1, 3, 1, 1)
        self.lineCaption1 = QtWidgets.QLineEdit(self.widget2)
        self.lineCaption1.setObjectName("lineCaption1")
        self.lineCaption1.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineCaption1, 1, 2, 1, 1)
        self.lblMenu2 = QtWidgets.QLabel(self.widget2)
        self.lblMenu2.setObjectName("lblMenu2")
        self.gridLayout_3.addWidget(self.lblMenu2, 2, 0, 1, 1)
        self.lineKode2 = QtWidgets.QLineEdit(self.widget2)
        self.lineKode2.setObjectName("lineKode2")
        self.lineKode2.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineKode2, 2, 1, 1, 1)
        self.lineTime2 = QtWidgets.QLineEdit(self.widget2)
        self.lineTime2.setObjectName("lineTime2")
        self.lineTime2.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineTime2, 2, 3, 1, 1)
        self.lineCaption2 = QtWidgets.QLineEdit(self.widget2)
        self.lineCaption2.setObjectName("lineCaption2")
        self.lineCaption2.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineCaption2, 2, 2, 1, 1)
        self.lblMenu3 = QtWidgets.QLabel(self.widget2)
        self.lblMenu3.setObjectName("lblMenu3")
        self.gridLayout_3.addWidget(self.lblMenu3, 3, 0, 1, 1)
        self.lineKode3 = QtWidgets.QLineEdit(self.widget2)
        self.lineKode3.setObjectName("lineKode3")
        self.lineKode3.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineKode3, 3, 1, 1, 1)
        self.lineTime3 = QtWidgets.QLineEdit(self.widget2)
        self.lineTime3.setObjectName("lineTime3")
        self.lineTime3.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineTime3, 3, 3, 1, 1)
        self.lineCaption3 = QtWidgets.QLineEdit(self.widget2)
        self.lineCaption3.setObjectName("lineCaption3")
        self.lineCaption3.returnPressed.connect(self.SaveSettingClicked)
        self.gridLayout_3.addWidget(self.lineCaption3, 3, 2, 1, 1)
        self.lblNote = QtWidgets.QLabel(self.frameSetting)
        self.lblNote.setGeometry(QtCore.QRect(730, 95, 274, 145))
        self.lblNote.setObjectName("lblNote")
        self.lblNote.setText("Time Note :\n 50ml  : 290\n 100ml : 580\n 150ml : 880\n 200ml : 1160\n 250ml : 1460")
        self.widget3 = QtWidgets.QWidget(self.frameSetting)
        self.widget3.setGeometry(QtCore.QRect(504, 255, 500, 30))
        self.widget3.setObjectName("widget3")
        self.gridLayout_4 = QtWidgets.QGridLayout(self.widget3)
        self.gridLayout_4.setContentsMargins(0, 0, 0, 0)
        self.gridLayout_4.setObjectName("gridLayout_4")
        self.CancelSaveBtn = QtWidgets.QPushButton(self.widget3)
        self.CancelSaveBtn.setObjectName("CancelSaveBtn")
        self.CancelSaveBtn.clicked.connect(self.CancelSettingClicked)
        self.CancelSaveBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayout_4.addWidget(self.CancelSaveBtn, 0, 2, 1, 1)
        self.SaveBtn = QtWidgets.QPushButton(self.widget3)
        self.SaveBtn.setObjectName("SaveBtn")
        self.SaveBtn.clicked.connect(self.SaveSettingClicked)
        self.SaveBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayout_4.addWidget(self.SaveBtn, 0, 3, 1, 1)
        self.widget4 = QtWidgets.QWidget(self.frameSetting)
        self.widget4.setGeometry(QtCore.QRect(20, 170, 700, 30))
        self.widget4.setObjectName("widget4")
        self.gridLayoutGB = QtWidgets.QGridLayout(self.widget4)
        self.gridLayoutGB.setContentsMargins(0, 0, 0, 0)
        self.gridLayoutGB.setObjectName("gridLayoutGB")
        self.GBSingle=QtWidgets.QRadioButton(self.widget4)
        self.GBSingle.setText("Single Payment")
        self.gridLayoutGB.addWidget(self.GBSingle, 0, 0, 1, 1)
        self.GBMulti=QtWidgets.QRadioButton(self.widget4)
        self.GBMulti.setText("Multi Payment")
        self.gridLayoutGB.addWidget(self.GBMulti, 0, 1, 1, 1)
        self.widgetBtnSetting = QtWidgets.QWidget(self.frameSetting)
        self.widgetBtnSetting.setGeometry(QtCore.QRect(730, 21, 274, 70))
        self.widgetBtnSetting.setObjectName("widgetBtnSetting")
        self.gridLayoutBtnSetting = QtWidgets.QGridLayout(self.widgetBtnSetting)
        self.gridLayoutBtnSetting.setContentsMargins(0, 0, 0, 0)
        self.gridLayoutBtnSetting.setObjectName("gridLayoutBtnSetting")
        self.RefreshImgBtn = QtWidgets.QPushButton(self.widgetBtnSetting)
        self.RefreshImgBtn.setObjectName("RefreshImgBtn")
        self.RefreshImgBtn.clicked.connect(self.RefreshImageBtnClicked)
        self.RefreshImgBtn.setText("Refresh Menu")
        self.RefreshImgBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayoutBtnSetting.addWidget(self.RefreshImgBtn, 1, 1, 1, 1)
        self.RefreshBGBtn = QtWidgets.QPushButton(self.widgetBtnSetting)
        self.RefreshBGBtn.setObjectName("RefreshBGBtn")
        self.RefreshBGBtn.clicked.connect(self.RefreshBGBtnClicked)
        self.RefreshBGBtn.setText("Refresh BG")
        self.RefreshBGBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayoutBtnSetting.addWidget(self.RefreshBGBtn, 2, 1, 1, 1)
        self.ResetIngredientBtn = QtWidgets.QPushButton(self.widgetBtnSetting)
        self.ResetIngredientBtn.setObjectName("ResetIngredientBtn")
        self.ResetIngredientBtn.clicked.connect(self.IngredientSettingClicked)
        self.ResetIngredientBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.gridLayoutBtnSetting.addWidget(self.ResetIngredientBtn, 3, 1, 1, 1)
        self.DailyBtn = QtWidgets.QPushButton(self.widgetBtnSetting)
        self.DailyBtn.setObjectName("DailyBtn")
        self.DailyBtn.clicked.connect(self.DailyClicked)
        self.DailyBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.DailyBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/Daily.png);")        
        self.gridLayoutBtnSetting.addWidget(self.DailyBtn, 1, 2, 1, 1)
        self.WeeklyBtn = QtWidgets.QPushButton(self.widgetBtnSetting)
        self.WeeklyBtn.setObjectName("WeeklyBtn")
        self.WeeklyBtn.clicked.connect(self.WeeklyClicked)
        self.WeeklyBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.WeeklyBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/Weekly.png);")
        self.gridLayoutBtnSetting.addWidget(self.WeeklyBtn, 2, 2, 1, 1)
        self.EmptyBtn = QtWidgets.QPushButton(self.widgetBtnSetting)
        self.EmptyBtn.setObjectName("EmptyBtn")
        self.EmptyBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.EmptyBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/Empty.png);")
        self.gridLayoutBtnSetting.addWidget(self.EmptyBtn, 3, 2, 1, 1)
        self.DailyBtn.hide()
        self.WeeklyBtn.hide()
        self.EmptyBtn.hide()
        self.ResetIngredientBtn.hide()
        self.frameRefreshInfo = QtWidgets.QFrame(self.frameSetting)
        self.frameRefreshInfo.setGeometry(QtCore.QRect(312, 150, 400, 100))        
        self.frameRefreshInfo.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameRefreshInfo.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameRefreshInfo.setObjectName("frameRefreshInfo")
        self.frameRefreshInfo.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.lblRefreshInfo = QtWidgets.QLabel(self.frameRefreshInfo)
        self.lblRefreshInfo.setGeometry(QtCore.QRect(5, 5, 390, 60))
        font = QtGui.QFont()
        font.setPointSize(14)
        self.lblRefreshInfo.setFont(font)
        self.lblRefreshInfo.setStyleSheet("color: rgb(0, 0, 0);")
        self.lblRefreshInfo.setAlignment(QtCore.Qt.AlignCenter)
        self.lblRefreshInfo.setObjectName("lblRefreshInfo")
        self.lblRefreshInfo.setText("Keterangan Refresh")
        self.RefreshInfoBtn = QtWidgets.QPushButton(self.frameRefreshInfo)
        self.RefreshInfoBtn.setObjectName("RefreshImgBtn")
        self.RefreshInfoBtn.setGeometry(QtCore.QRect(150, 70, 100, 25))
        self.RefreshInfoBtn.clicked.connect(self.CloseRefreshInfo)
        self.RefreshInfoBtn.setText("Close")
        self.RefreshInfoBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.frameRefreshInfo.hide()
        self.RefreshType=""
        #frame Ingredient Setting
        self.TmpWaterQty=10000
        self.TmpCupQty=60
        self.TmpM1Qty=1000
        self.TmpM2Qty=1000
        self.TmpM3Qty=1000
        self.frameIngredientSetting = QtWidgets.QFrame(Dialog)
        self.frameIngredientSetting.setGeometry(QtCore.QRect(0, 0, 1024, 600))
        self.frameIngredientSetting.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameIngredientSetting.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameIngredientSetting.setObjectName("frameIngredientSetting")
        self.frameIngredientSetting.setStyleSheet("background-color: rgb(255, 255, 255);")
        self.frameIngredientSetting.hide()
        self.BackToSettingBtn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.BackToSettingBtn.setGeometry(QtCore.QRect(5, 545, 50, 50))
        self.BackToSettingBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.BackToSettingBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                    "QPushButton:pressed {background-color: blue}")
        self.BackToSettingBtn.setFont(tmpfont)
        self.BackToSettingBtn.setText("Back")
        self.BackToSettingBtn.clicked.connect(self.BackClicked)
        self.NextStepBtn2 = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.NextStepBtn2.setGeometry(QtCore.QRect(0, 545, 1024, 50))
        self.NextStepBtn2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.NextStepBtn2.setStyleSheet("QPushButton {background-color: red; color: white; border: none}"
                                    "QPushButton:pressed {background-color: blue}")
        self.NextStepBtn2.setFont(tmpfont)
        self.NextStepBtn2.setText("Update All and Next")
        self.NextStepBtn2.hide()
        self.NextStepBtn2.clicked.connect(self.NextStepBtn2Clicked)
        self.ResetWaterBtn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetWaterBtn.setGeometry(QtCore.QRect(55, 90, 75, 75))
        self.ResetWaterBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetWaterBtn.setFont(tmpfont)
        #self.ResetWaterBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetWater.png);")
        #self.ResetWaterBtn.clicked.connect()
        self.lineQtyWater = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyWater.setObjectName("lineQtyWater")
        self.lineQtyWater.setGeometry(QtCore.QRect(150, 112, 200, 30))
        self.lineQtyWater.setFont(tmpfont)
        self.lineQtyWater.setText(str(self.TmpWaterQty))
        self.lblWaterUnit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblWaterUnit.setObjectName("lblWaterUnit")
        self.lblWaterUnit.setGeometry(QtCore.QRect(360, 112, 30, 30))
        self.lblWaterUnit.setFont(tmpfont)
        self.lblWaterUnit.setText("ml")
        self.ResetCupBtn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetCupBtn.setGeometry(QtCore.QRect(55, 180, 75, 75))
        self.ResetCupBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetCupBtn.setFont(tmpfont)
        #self.ResetCupBtn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetCup.png);")
        #self.ResetCupBtn.clicked.connect()
        self.lineQtyCup = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyCup.setObjectName("lineQtyCup")
        self.lineQtyCup.setGeometry(QtCore.QRect(150, 202, 200, 30))
        self.lineQtyCup.setFont(tmpfont)
        self.lineQtyCup.setText(str(self.TmpCupQty))
        self.lblCupUnit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblCupUnit.setObjectName("lblCupUnit")
        self.lblCupUnit.setGeometry(QtCore.QRect(360, 202, 30, 30))
        self.lblCupUnit.setFont(tmpfont)
        self.lblCupUnit.setText("cup")
        self.ResetMenu1Btn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetMenu1Btn.setGeometry(QtCore.QRect(55, 270, 75, 75))
        self.ResetMenu1Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetMenu1Btn.setFont(tmpfont)
        #self.ResetMenu1Btn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetM1.png);")
        #self.ResetMenu1Btn.clicked.connect()
        self.lineQtyMenu1 = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyMenu1.setObjectName("lineQtyMenu1")
        self.lineQtyMenu1.setGeometry(QtCore.QRect(150, 292, 200, 30))
        self.lineQtyMenu1.setFont(tmpfont)
        self.lineQtyMenu1.setText(str(self.TmpM1Qty))
        self.lblMenu1Unit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblMenu1Unit.setObjectName("lblMenu1Unit")
        self.lblMenu1Unit.setGeometry(QtCore.QRect(360, 292, 30, 30))
        self.lblMenu1Unit.setFont(tmpfont)
        self.lblMenu1Unit.setText("gr")
        self.ResetMenu2Btn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetMenu2Btn.setGeometry(QtCore.QRect(55, 360, 75, 75))
        self.ResetMenu2Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetMenu2Btn.setFont(tmpfont)
        #self.ResetMenu2Btn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetM2.png);")
        #self.ResetMenu2Btn.clicked.connect()
        self.lineQtyMenu2 = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyMenu2.setObjectName("lineQtyMenu2")
        self.lineQtyMenu2.setGeometry(QtCore.QRect(150, 382, 200, 30))
        self.lineQtyMenu2.setFont(tmpfont)
        self.lineQtyMenu2.setText(str(self.TmpM2Qty))
        self.lblMenu2Unit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblMenu2Unit.setObjectName("lblMenu2Unit")
        self.lblMenu2Unit.setGeometry(QtCore.QRect(360, 382, 30, 30))
        self.lblMenu2Unit.setFont(tmpfont)
        self.lblMenu2Unit.setText("gr")
        self.ResetMenu3Btn = QtWidgets.QPushButton(self.frameIngredientSetting)
        self.ResetMenu3Btn.setGeometry(QtCore.QRect(55, 450, 75, 75))
        self.ResetMenu3Btn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ResetMenu3Btn.setFont(tmpfont)
        #self.ResetMenu3Btn.setStyleSheet("border-image: url(/home/pi/Documents/OmegaCoffee/Img/ResetM3.png);")
        #self.ResetMenu3Btn.clicked.connect()
        self.lineQtyMenu3 = QtWidgets.QLineEdit(self.frameIngredientSetting)
        self.lineQtyMenu3.setObjectName("lineQtyMenu3")
        self.lineQtyMenu3.setGeometry(QtCore.QRect(150, 472, 200, 30))
        self.lineQtyMenu3.setFont(tmpfont)
        self.lineQtyMenu3.setText(str(self.TmpM3Qty))
        self.lblMenu3Unit = QtWidgets.QLabel(self.frameIngredientSetting)
        self.lblMenu3Unit.setObjectName("lblMenu3Unit")
        self.lblMenu3Unit.setGeometry(QtCore.QRect(360, 472, 30, 30))
        self.lblMenu3Unit.setFont(tmpfont)
        self.lblMenu3Unit.setText("gr")
        self.widgetNumPad = QtWidgets.QWidget(self.frameIngredientSetting)
        self.widgetNumPad.setGeometry(QtCore.QRect(750, 145, 180, 330))
        self.widgetNumPad.setObjectName("widgetNumPad")
        self.gridLayoutNumPad = QtWidgets.QGridLayout(self.widgetNumPad)
        self.gridLayoutNumPad.setContentsMargins(0, 0, 0, 0)
        self.gridLayoutNumPad.setObjectName("gridLayoutNumPad")
        self.ArrNumPad=["7", "8", "9", "4", "5", "6", "1", "2", "3", "CE", "0", "C"]
        self.btnnum=[]
        for x in range(len(self.ArrNumPad)):
            self.btn.append(x)
            self.btn[x]=QtWidgets.QPushButton(self.frameIngredientSetting)
            txtKey = self.ArrNumPad[x]
            self.btn[x].setText(txtKey)
            self.btn[x].setFocusPolicy(QtCore.Qt.NoFocus)
            self.gridLayoutNumPad.addWidget(self.btn[x], x//3, x%3, 1, 1)
            self.btn[x].clicked.connect(lambda checked, a=x : self.NumPadClicked(a))    
        #line QR
        self.lineQR = QtWidgets.QLineEdit(Dialog)
        self.lineQR.setGeometry(QtCore.QRect(50, 610, 350, 23))
        self.lineQR.setObjectName("lineQR")
        self.lineQR.hide()
        #frame Payment        
        self.framePayment = QtWidgets.QFrame(Dialog)
        self.framePayment.setGeometry(QtCore.QRect(0, 160, 1024, 450))
        self.framePayment.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.framePayment.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.framePayment.setFrameShadow(QtWidgets.QFrame.Raised)
        self.framePayment.setObjectName("framePayment")
        self.GoPayBtn = QtWidgets.QPushButton(self.framePayment)
        self.GoPayBtn.setGeometry(QtCore.QRect(0, 5, 1024, 145))
        #self.GoPayBtn.setGeometry(QtCore.QRect(0, 5, 1024, 105))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.GoPayBtn.setFont(font)
        self.GoPayBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none}"
                                    "QPushButton:pressed {background-color: blue}")
        self.GoPayBtn.setObjectName("GoPayBtn")
        self.GoPayBtn.clicked.connect(self.GoPayClicked)
        self.LinkAjaBtn = QtWidgets.QPushButton(self.framePayment)
        self.LinkAjaBtn.setGeometry(QtCore.QRect(0, 155, 1024, 145))
        #self.LinkAjaBtn.setGeometry(QtCore.QRect(0, 115, 1024, 105))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.LinkAjaBtn.setFont(font)
        self.LinkAjaBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none}"
                                      "QPushButton:pressed {background-color: blue}")
        self.LinkAjaBtn.setObjectName("LinkAjaBtn")
        self.LinkAjaBtn.clicked.connect(self.LinkAjaClicked)        
        self.ShopeeBtn = QtWidgets.QPushButton(self.framePayment)
        self.ShopeeBtn.setGeometry(QtCore.QRect(0, 225, 1024, 105))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.ShopeeBtn.setFont(font)
        self.ShopeeBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none}"
                                         "QPushButton:pressed {background-color: blue}")
        self.ShopeeBtn.setObjectName("ShopeeBtn")
        self.ShopeeBtn.clicked.connect(self.ShopeeClicked)
        self.LaundroMatBtn = QtWidgets.QPushButton(self.framePayment)
        self.LaundroMatBtn.setGeometry(QtCore.QRect(0, 335, 1024, 105))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(48)
        self.LaundroMatBtn.setFont(font)
        self.LaundroMatBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none}"
                                         "QPushButton:pressed {background-color: blue}")
        self.LaundroMatBtn.setObjectName("LaundroMatBtn")
        self.LaundroMatBtn.clicked.connect(self.LaundroMatClicked)
        self.CancelPaymentBtn = QtWidgets.QPushButton(self.framePayment)
        self.CancelPaymentBtn.setGeometry(QtCore.QRect(0, 305, 1024, 145))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setFamily("Sans Serif")
        font.setPointSize(28)
        self.CancelPaymentBtn.setFont(font)
        self.CancelPaymentBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none}"
                                            "QPushButton:pressed {background-color: blue}")
        self.CancelPaymentBtn.setObjectName("CancelPaymentBtn")
        self.CancelPaymentBtn.clicked.connect(self.CancelPayment)
        self.framePayment.hide()        
        #frame Payment test   
        self.framePayment2 = QtWidgets.QFrame(Dialog)
        self.framePayment2.setGeometry(QtCore.QRect(0, 160, 1024, 450))
        self.framePayment2.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.framePayment2.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.framePayment2.setFrameShadow(QtWidgets.QFrame.Raised)
        self.framePayment2.setObjectName("framePayment2")
        self.CancelPaymentBtn2 = QtWidgets.QPushButton(self.framePayment2)
        self.CancelPaymentBtn2.setGeometry(QtCore.QRect(200, 325, 624, 100))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setFamily("Sans Serif")
        font.setPointSize(28)
        self.CancelPaymentBtn2.setFont(font)
        self.CancelPaymentBtn2.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                            "border-style: outset; border-width: 2px; border-radius: 10px;"
                                            "border-color: beige;padding: 6px;}"
                                            "QPushButton:pressed {background-color: blue};")
        self.CancelPaymentBtn2.setFocusPolicy(QtCore.Qt.NoFocus)
        self.CancelPaymentBtn2.setObjectName("CancelPaymentBtn2")
        self.CancelPaymentBtn2.clicked.connect(self.CancelPayment)
        self.btnPay=[]
        for y in range(6):
            self.btnPay.append(y)
            self.btnPay[y]=QtWidgets.QPushButton(self.framePayment2)
            font = QtGui.QFont()
            font.setFamily("Quicksand Medium")
            font.setPointSize(48)
            self.btnPay[y].setFont(font)
            self.btnPay[y].setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                        "border-style: outset; border-width: 2px; border-radius: 10px;"
                                        "border-color: beige;padding: 6px;}"
                                        "QPushButton:pressed {background-color: blue};")
            self.btnPay[y].setText(str(y))
            self.btnPay[y].setGeometry(QtCore.QRect((2+y//3*512), (2+y%3*100), 508, 106))
            self.btnPay[y].setFocusPolicy(QtCore.Qt.NoFocus)
            self.btnPay[y].clicked.connect(lambda checked, a=y : self.ModePayClicked(a))
        self.ModePay=[]
        self.framePayment2.hide()
        #frame SinglePayment        
        self.frameSinglePayment = QtWidgets.QFrame(Dialog)
        self.frameSinglePayment.setGeometry(QtCore.QRect(0, 160, 1024, 440))
        self.frameSinglePayment.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.frameSinglePayment.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameSinglePayment.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameSinglePayment.setObjectName("frameSinglePayment")
        self.lblInfoTimer = QtWidgets.QLabel(self.frameSinglePayment)
        self.lblInfoTimer.setGeometry(QtCore.QRect(0, 310, 50, 20))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(12)
        self.lblInfoTimer.setFont(font)
        self.lblInfoTimer.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInfoTimer.setAlignment(QtCore.Qt.AlignLeft)
        self.lblInfoTimer.setObjectName("lblInfoTimer")
        self.lblInfoTimer.hide()
        self.webSingleQR = QtWebKitWidgets.QWebView(self.frameSinglePayment)
        self.webSingleQR.setGeometry(QtCore.QRect(347, 0, 330, 330))
        self.webSingleQR.setUrl(QtCore.QUrl("http://www.google.com/"))
        self.webSingleQR.setObjectName("webSingleQR")
        self.CancelSinglePaymentBtn = QtWidgets.QPushButton(self.frameSinglePayment)
        self.CancelSinglePaymentBtn.setGeometry(QtCore.QRect(200, 330, 624, 80))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setFamily("Sans Serif")
        font.setPointSize(28)
        self.CancelSinglePaymentBtn.setFont(font)
        self.CancelSinglePaymentBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.CancelSinglePaymentBtn.setObjectName("CancelSinglePaymentBtn")
        self.CancelSinglePaymentBtn.clicked.connect(self.CancelPayment)
        self.lblQRSingle = QtWidgets.QLabel(self.frameSinglePayment)
        self.lblQRSingle.setGeometry(QtCore.QRect(347, 0, 330, 330))
        self.lblQRSingle.setText("")
        self.lblQRSingle.setObjectName("lblQRSingle")
        self.lblQRSingle.hide()
        self.frameSinglePayment.hide()
        #frame Multi
        self.frameMultiPayment = QtWidgets.QFrame(Dialog)
        self.frameMultiPayment.setGeometry(QtCore.QRect(0, 160, 1024, 440))
        self.frameMultiPayment.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none ")
        self.frameMultiPayment.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameMultiPayment.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameMultiPayment.setObjectName("frameMultiPayment")
        self.webMultiQR = QtWebKitWidgets.QWebView(self.frameMultiPayment)
        self.webMultiQR.setGeometry(QtCore.QRect(347, 0, 330, 330))
        self.webMultiQR.setUrl(QtCore.QUrl("http://www.google.com/"))
        self.webMultiQR.setObjectName("webMultiQR")
        self.CancelMultiPaymentBtn = QtWidgets.QPushButton(self.frameMultiPayment)
        self.CancelMultiPaymentBtn.setGeometry(QtCore.QRect(200, 330, 624, 80))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setFamily("Sans Serif")
        font.setPointSize(28)
        self.CancelMultiPaymentBtn.setFont(font)
        self.CancelMultiPaymentBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.CancelMultiPaymentBtn.setObjectName("CancelSinglePaymentBtn")
        self.CancelMultiPaymentBtn.clicked.connect(self.CancelPayment)
        self.frameMultiPayment.hide()        
        #webView QR
        self.webView = QtWebKitWidgets.QWebView(Dialog)
        self.webView.setGeometry(QtCore.QRect(0, 160, 1024, 310))
        self.webView.setUrl(QtCore.QUrl("http://www.google.com/"))
        self.webView.setObjectName("webView")
        self.webView.hide()
        #frame Help
        self.StepCount=1
        self.HelpSelected=""
        self.WebStepSelected=[]
        self.WebStepDaily=["http://www.google.com/", "http://www.kaskus.co.id/"]
        self.WebStepWeekly=["http://www.google.com/", "http://www.kaskus.co.id/", "http://www.google.com/"]
        self.frameHelp = QtWidgets.QFrame(Dialog)
        self.frameHelp.setGeometry(QtCore.QRect(0, 0, 1024, 610))
        self.frameHelp.setStyleSheet("background-color: rgb(0,0,0); border : none")
        self.frameHelp.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameHelp.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameHelp.setObjectName("frameHelp")
        self.lblStep = QtWidgets.QLabel(self.frameHelp)
        self.lblStep.setGeometry(QtCore.QRect(0, 5, 1024, 30))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(25)
        self.lblStep.setFont(font)
        self.lblStep.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblStep.setAlignment(QtCore.Qt.AlignCenter)
        self.lblStep.setObjectName("lblStep")
        self.lblTimerCD = QtWidgets.QLabel(self.frameHelp)
        self.lblTimerCD.setGeometry(QtCore.QRect(0, 40, 1024, 500))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(40)
        self.lblTimerCD.setFont(font)
        self.lblTimerCD.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblTimerCD.setAlignment(QtCore.Qt.AlignCenter)
        self.lblTimerCD.setObjectName("lblTimerCD")
        self.lblTimerCD.hide()
        self.webHelp = QtWebKitWidgets.QWebView(self.frameHelp)
        self.webHelp.setGeometry(QtCore.QRect(0, 40, 1024, 500))
        #self.webHelp.setUrl(QtCore.QUrl("http://www.google.com/"))
        self.webHelp.setObjectName("webHelp")
        self.NextHelpBtn = QtWidgets.QPushButton(self.frameHelp)
        self.NextHelpBtn.setGeometry(QtCore.QRect(5, 545, 1014, 50))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(25)
        self.NextHelpBtn.setFont(font)
        self.NextHelpBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none}"
                                         "QPushButton:pressed {background-color: blue}")
        self.NextHelpBtn.setObjectName("NextHelpBtn")
        self.NextHelpBtn.clicked.connect(self.NextHelpClicked)     
        self.frameHelp.hide()
        #frame Information
        self.frameInformation = QtWidgets.QFrame(Dialog)
        self.frameInformation.setGeometry(QtCore.QRect(0, 160, 1024, 440))
        self.frameInformation.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.frameInformation.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameInformation.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameInformation.setObjectName("frameInformation")
        self.lblInformation = QtWidgets.QLabel(self.frameInformation)
        self.lblInformation.setGeometry(QtCore.QRect(5, 0, 1014, 240))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(30)
        self.lblInformation.setFont(font)
        self.lblInformation.setStyleSheet(fontclnew)
        self.lblInformation.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInformation.setObjectName("lblInformation")
        self.lblInfoCD = QtWidgets.QLabel(self.frameInformation)
        self.lblInfoCD.setGeometry(QtCore.QRect(5, 240, 1014, 60))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(20)
        self.lblInfoCD.setFont(font)
        self.lblInfoCD.setStyleSheet(fontclnew)
        self.lblInfoCD.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInfoCD.setObjectName("lblInfoCD")
        #self.lblInfoCD.setText("Mohon Tunggu\n")
        self.BackToMainBtn = QtWidgets.QPushButton(self.frameInformation)
        self.BackToMainBtn.setGeometry(QtCore.QRect(200, 330, 624, 80))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(28)
        self.BackToMainBtn.setFont(font)
        self.BackToMainBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.BackToMainBtn.setObjectName("BackToMainBtn")
        self.BackToMainBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.BackToMainBtn.clicked.connect(self.CancelPayment)
        self.frameInformation.hide()
        #frameInformation2
        self.frameInformation2 = QtWidgets.QFrame(Dialog)
        self.frameInformation2.setGeometry(QtCore.QRect(0, 160, 1024, 440))
        self.frameInformation2.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.frameInformation2.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameInformation2.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameInformation2.setObjectName("frameInformation2")
        self.lblInformation2 = QtWidgets.QLabel(self.frameInformation2)
        self.lblInformation2.setGeometry(QtCore.QRect(5, 0, 1014, 240))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(30)
        self.lblInformation2.setFont(font)
        self.lblInformation2.setStyleSheet(fontclnew)
        self.lblInformation2.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInformation2.setObjectName("lblInformation2")
        self.lblInfoCD2 = QtWidgets.QLabel(self.frameInformation2)
        self.lblInfoCD2.setGeometry(QtCore.QRect(5, 240, 1014, 60))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(20)
        self.lblInfoCD2.setFont(font)
        self.lblInfoCD2.setStyleSheet("color: rgb(255, 255, 255);")
        self.lblInfoCD2.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInfoCD2.setObjectName("lblInfoCD2")
        #self.lblInfoCD2.setText("Mohon Tunggu\n")
        self.NextCupBtn = QtWidgets.QPushButton(self.frameInformation2)
        self.NextCupBtn.setGeometry(QtCore.QRect(200, 330, 624, 80))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(28)
        self.NextCupBtn.setFont(font)
        self.NextCupBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.NextCupBtn.setObjectName("NextCupBtn")
        self.NextCupBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.NextCupBtn.clicked.connect(self.NextCupClicked)
        self.frameInformation2.hide()
        #frame Progress
        self.frameProgress = QtWidgets.QFrame(Dialog)
        self.frameProgress.setGeometry(QtCore.QRect(0, 160, 1024, 440))
        self.frameProgress.setStyleSheet("background-color: rgba(0, 0, 0, 0); border : none")
        self.frameProgress.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameProgress.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameProgress.setObjectName("frameProgress")
        self.lblInfoProgress = QtWidgets.QLabel(self.frameProgress)
        self.lblInfoProgress.setGeometry(QtCore.QRect(5, 5, 1014, 300))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(24)
        self.lblInfoProgress.setFont(font)
        self.lblInfoProgress.setStyleSheet(fontclnew)
        self.lblInfoProgress.setAlignment(QtCore.Qt.AlignCenter)
        self.lblInfoProgress.setObjectName("lblInformation2")
        self.ProgressBackBtn = QtWidgets.QPushButton(self.frameProgress)
        self.ProgressBackBtn.setGeometry(QtCore.QRect(200, 330, 624, 80))
        font = QtGui.QFont()
        font.setFamily("Quicksand Medium")
        font.setPointSize(28)
        self.ProgressBackBtn.setFont(font)
        self.ProgressBackBtn.setStyleSheet("QPushButton {background-color: "+clbutton+"; "+fontclnew+"; border: none;"
                                    "border-style: outset; border-width: 2px; border-radius: 10px;"
                                    "border-color: beige;padding: 6px;}"
                                    "QPushButton:pressed {background-color: blue};")
        self.ProgressBackBtn.setObjectName("NextCupBtn")
        self.ProgressBackBtn.setFocusPolicy(QtCore.Qt.NoFocus)
        self.ProgressBackBtn.clicked.connect(self.CancelPayment)
        self.ProgressBackBtn.hide()
        self.frameProgress.hide()
        #frame QR
        self.frameQR = QtWidgets.QFrame(Dialog)
        self.frameQR.setGeometry(QtCore.QRect(0, 160, 1024, 330))
        self.frameQR.setStyleSheet("background-color: rgba(255, 255, 255, 0); border : none")
        self.frameQR.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frameQR.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frameQR.setObjectName("frameQR")
        self.lblQR = QtWidgets.QLabel(self.frameQR)
        self.lblQR.setGeometry(QtCore.QRect(440, 10, 400, 400))
        self.lblQR.setText("")
        self.lblQR.setObjectName("lblQR")
        #self.lblQR.setStyleSheet("background-color: black")
        self.frameQR.hide()
        
        self.channel1=6 #26
        self.channel2=13 #19
        self.channel3=19 #13
        self.channel4=26 #6
        self.channel5=18
        setPin(self.channel1, self.channel2, self.channel3, self.channel4, self.channel5)
        DisconnectRelay(self.channel1)
        DisconnectRelay(self.channel2)
        DisconnectRelay(self.channel3)
        DisconnectRelay(self.channel5)
        self.i=0
        self.j=0
        self.TimerPay=QTimer()
        self.TimerPay.setInterval(1000)
        self.TimerPay.timeout.connect(self.TimerPayOn)
        self.TimerStatus=QTimer()
        self.TimerStatus.setInterval(10)
        self.TimerStatus.timeout.connect(self.TimerStatusOn)
        #self.TimerStatus.timeout.connect(self.TinerStatus2)
        self.k=0
        self.TimerInternet=QTimer()
        self.TimerInternet.setInterval(1000)
        self.TimerInternet.timeout.connect(self.TimerInternetOn)
        self.TimerInternet.start()
        self.l=0
        self.TimerProgress=QTimer()
        self.TimerProgress.setInterval(250)
        self.TimerProgress.timeout.connect(self.TimerProgressOn)
        self.m=600
        self.TimerCD=QTimer()
        self.TimerCD.setInterval(1000)
        self.TimerCD.timeout.connect(self.TimerCDOn)
        self.o=0
        self.TimerAutoBack=QTimer()
        self.TimerAutoBack.setInterval(1000)
        self.TimerAutoBack.timeout.connect(self.TimerAutoBackOn)
        self.q=0
        self.TimerRefreshInfo=QTimer()
        self.TimerRefreshInfo.setInterval(500)
        self.TimerRefreshInfo.timeout.connect(self.TimerRefreshInfoOn)
        self.r=0
        self.TimerSendAct=QTimer()
        self.TimerSendAct.setInterval(1000)
        self.TimerSendAct.timeout.connect(self.TimerSendActOn)
        self.TimerSendAct.start()
        
        self.MenuSelected=""
        self.TrxID=""
        self.OrderQty=1
        
        self.UserID = "admin"
        self.Password = "omega"        
                   
        self.Staff = ""
        self.Kode1 = ""
        self.Kode2 = ""
        self.Kode3 = ""
        self.Caption1 = "Menu 1"
        self.Caption2 = "Menu 2"
        self.Caption3 = "Menu 3"
        self.varTime1 = "0"
        self.varTime2 = "0"
        self.varTime3 = "0"
        self.TypePay = "Multi"
        
        self.src_dir=os.curdir
        self.fileSetting="/home/pi/Documents/OmegaSanitizer/Setting.txt"
        self.fileSettingBackup="/home/pi/Documents/OmegaSanitizer/SettingBackup.txt"
        self.fileExist=CheckFile(self.fileSetting)
        self.fileBackupExist=CheckFile(self.fileSettingBackup)
        self.TypePay=""
        if self.fileBackupExist :
            if self.fileExist==False :
                shutil.copy(self.fileSettingBackup, self.fileSetting)
                self.fileExist=CheckFile(self.fileSetting)
        if self.fileExist :
            with open(self.fileSetting) as search:
                for line in search:
                    line=line.rstrip()
                    if "Staff" in line :
                        self.Staff=line.replace("Staff : ", "")
                    elif "Kode1" in line :
                        self.Kode1=line.replace("Kode1 : ", "")
                    elif "Caption1" in line :
                        self.Caption1=line.replace("Caption1 : ", "")
                    elif "Time1" in line :
                        self.varTime1=line.replace("Time1 : ", "")
                    elif "Kode2" in line :
                        self.Kode2=line.replace("Kode2 : ", "")
                    elif "Caption2" in line :
                        self.Caption2=line.replace("Caption2 : ", "")
                    elif "Time2" in line :
                        self.varTime2=line.replace("Time2 : ", "")
                    elif "Kode3" in line :
                        self.Kode3=line.replace("Kode3 : ", "")
                    elif "Caption3" in line :
                        self.Caption3=line.replace("Caption3 : ", "")
                    elif "Time3" in line :
                        self.varTime3=line.replace("Time3 : ", "")
                    elif "TypePay" in line :
                        self.TypePay=line.replace("TypePay : ", "")
        else :            
            self.Staff = ""
            self.Kode1 = ""
            self.Kode2 = ""
            self.Kode3 = ""
            self.Caption1 = "Menu 1"
            self.Caption2 = "Menu 2"
            self.Caption3 = "Menu 3"
            self.varTime1 = "0"
            self.varTime2 = "0"
            self.varTime3 = "0"
            self.TypePay = "Multi"
        
        self.fileVersi="/home/pi/Documents/OmegaSanitizer/Versi.txt"
        self.Versi=""
        if CheckFile(self.fileVersi):
            with open(self.fileVersi) as search:
                for line in search:
                    line=line.rstrip()
                    if "Versi" in line :
                        self.Versi=line.replace("Versi=", "")
        else :
            self.Versi="Unknown"            
        self.lblVersion.setText("V."+self.Versi)
        
        self.TimeRelayStop=0
               
        self.payCancel=False
        self.tryCancel=0
        self.fileLogTrans="/home/pi/Documents/OmegaSanitizer/LogTrans.txt" 
        self.IsException=False
        self.ImageBGHome=""
        self.ImageBGQR=""
        self.ImageBGInfo=""
        self.ImageBGProgress=""
        self.imageBGHome=""
        self.imageBGQR=""
        self.imageBGInfo=""
        self.imageBGprogress=""
        self.IsSingleQR=False
        
        self.InitialSetting()

        self.retranslateUi(Dialog)
        QtCore.QMetaObject.connectSlotsByName(Dialog)
        
    def CheckConnection(self):
        try:
            host=socket.gethostbyname("1.1.1.1")
            s = socket.create_connection((host, 80), 1)
            s.close()
            return True
            print("Connect")
        except Exception as err:
            return False
            print("Not Connect "+ err.__class__.__name__)
            
    def UpdateProgramV2(self):
        mainpy="/home/pi/Documents/OmegaSanitizer/MainSanitizer.py"
        versitxt="/home/pi/Documents/OmegaSanitizer/Versi.txt"
        apiso="/home/pi/Documents/OmegaSanitizer/Api.cpython-37m-arm-linux-gnueabihf.so"
        bumainpy="/home/pi/Documents/OmegaSanitizer/MainSanitizerBU.py"
        buversitxt="/home/pi/Documents/OmegaSanitizer/VersiBU.txt"
        buapiso="/home/pi/Documents/OmegaSanitizer/Api.cpython-37m-arm-linux-gnueabihfBU.so"
        if CheckFile(mainpy) and CheckFile(versitxt) and CheckFile(apiso):
            shutil.copy(mainpy, bumainpy)
            shutil.copy(versitxt, buversitxt)
            shutil.copy(apiso, buapiso)
        try :
            #check versi
            vercurrent=0
            encoding="utf-8"
            data = urlopen("http://www.omegasoft.co.id/download/IOT/Sanitizer/Versi.txt")
            for line in data :
                verprog=str(line, encoding)
                verprog=verprog.replace("Versi=", "")
                print("Update Version : "+verprog)                
            fileExist=os.path.isfile("/home/pi/Documents/OmegaSanitizer/Versi.txt")
            if fileExist :
                with open("/home/pi/Documents/OmegaSanitizer/Versi.txt") as search:
                    for line in search:
                        line=line.rstrip()
                        vercurrent=line.replace("Versi=","")
                        print("Current Version : "+vercurrent)                     
            print("Current-Web : "+vercurrent+"-"+verprog) 
            
            if int(verprog)>int(vercurrent) :
                print("Update Program Start")
                url="http://www.omegasoft.co.id/download/IOT/Sanitizer/Versi.txt"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaSanitizer/Versi.txt", "wb") as f:
                    f.write(datatowrite)
                url="http://www.omegasoft.co.id/download/IOT/Sanitizer/MainSanitizer.py"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaSanitizer/MainSanitizer.py", "wb") as f:
                    f.write(datatowrite)
                url="http://www.omegasoft.co.id/download/IOT/Sanitizer/Api.cpython-37m-arm-linux-gnueabihf.so"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaSanitizer/Api.cpython-37m-arm-linux-gnueabihf.so", "wb") as f:
                    f.write(datatowrite)
                print("Update Finished")
                print("Reboot")
                os.system("sudo shutdown -r now")
            else :
                print("Not Updating")
            #delete file backup
            if CheckFile(bumainpy) and CheckFile(buversitxt) and CheckFile(buapiso):
                os.remove(buversitxt)
                os.remove(buapiso)
                os.remove(bumainpy)
        except Exception as e :
            #kembalikan ke versi sebelumnya jika terjadi error saat update
            if CheckFile(bumainpy) and CheckFile(buversitxt) and CheckFile(buapiso):
                shutil.copy(bumainpy, mainpy)
                shutil.copy(buversitxt, versitxt)
                shutil.copy(buapiso, apiso)
                os.remove(buversitxt)
                os.remove(buapiso)
                os.remove(bumainpy)
            print("Terjadi kesalahan "+e.__class__.__name__)        
            
    def InitialSetting(self):
        isconnect=self.CheckConnection()
        self.getPaymentMode=False
        self.IsSingleQR=False
        self.ModePay.clear()
        if isconnect :
            print("Connect")
            self.UpdateProgramV2()
            self.z=0
            while True:
                hasiltipe=Api.CekTipePayment(self.Staff)
                #print("Hasil tipe : "+hasiltipe)
                if "Terjadi Kesalahan" in hasiltipe:
                    if self.z>5:
                        break
                else :
                    if ("Gopay" in hasiltipe) or ("LinkAja" in hasiltipe) or ("Shopee" in hasiltipe) :
                        if "GoPay" in hasiltipe:
                            self.ModePay.append("GoPay")
                        if "LinkAja" in hasiltipe:
                            self.ModePay.append("LinkAja")
                        if "Shopee" in hasiltipe:
                            self.ModePay.append("Shopee")
                            self.IsSingleQR=True
                        self.getPaymentMode=True
                    self.RedrawPayment()
                    break            
                self.z+=1            
            self.UpdateBGImage()
            self.UpdateButtonImage()
            self.UpdateMenuPrice()
            self.UpdateBGImage2()
        else:
            print("not connect")
            
    def GoToMainMenu(self):
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGHome))
        
    def GoToProgress(self):
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGprogress))
        
    def GoToInfo(self):        
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGInfo))
        
    def GoToQR(self):
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGQR))
        
    def UpdateBGImage2(self):
        try :
            print("get all bg")
            bgdate=""
            qrdate=""
            infodate=""
            progdate=""
            update1=False
            update2=False
            update3=False
            update4=False
            if CheckFile("/home/pi/Documents/OmegaSanitizer/BGData.txt") :
                with open("/home/pi/Documents/OmegaSanitizer/BGData.txt") as search:
                    for line in search:
                        line=line.rstrip()
                        if "BGDate=" in line :
                            bgdate=line.replace("BGDate=","")
                            #print("Current BG Date : "+bgdate) 
                        elif "QRDate=" in line :
                            qrdate=line.replace("QRDate=","")
                            #print("Current QR Date : "+qrdate)                        
                        elif "InfoDate=" in line :
                            infodate=line.replace("InfoDate=","")
                            #print("Current Info Date : "+infodate)
                        elif "ProgDate=" in line :
                            progdate=line.replace("ProgDate=","")
                            #print("Current Prog Date : "+progdate)                
                #print("Current BG Date : "+bgdate)
                #print("Current QR Date : "+qrdate)
                #print("Current Info Date : "+infodate)
                #print("Current Prog Date : "+progdate)                
            r=requests.post("http://api-prod.omegasoft.co.id/v3/Iot_omega/detailgambariot", data={'token':'ojdhKKlhdbsmd2345djjshdjsdhjhjjfsf', 'UID':'2308jdhjhsjshfJJkshdkwrvsuonzMMh', 'branch':self.Staff[0:5], 'tipeiot':'SANITIZER'})
            result=json.loads(r.text)
            print(result)
            listgbr=result.get("data")
            if len(listgbr)> 0 :
                dirgbr1="/home/pi/Documents/OmegaSanitizer/Img/BGHome.jpg"
                dirgbr2="/home/pi/Documents/OmegaSanitizer/Img/BGQR.jpg"
                dirgbr3="/home/pi/Documents/OmegaSanitizer/Img/BGInfo.jpg"
                dirgbr4="/home/pi/Documents/OmegaSanitizer/Img/BGProgress.jpg"
                gbr1=result.get("data")["Gambar1"]
                date1=result.get("data")["TglGambar1"]
                gbr2=result.get("data")["Gambar2"]
                date2=result.get("data")["TglGambar2"]
                gbr3=result.get("data")["Gambar3"]
                date3=result.get("data")["TglGambar3"]
                gbr4=result.get("data")["Gambar4"]
                date4=result.get("data")["TglGambar4"]
                
                if bgdate=="":
                    update1=True
                else :
                    time1=time.mktime(time.strptime(bgdate, "%Y-%m-%d %H:%M:%S"))
                    time2=time.mktime(time.strptime(date1, "%Y-%m-%d %H:%M:%S"))
                    if time2 > time1 :
                        update1=True
                if qrdate=="":
                    update2=True
                else :
                    time1=time.mktime(time.strptime(qrdate, "%Y-%m-%d %H:%M:%S"))
                    time2=time.mktime(time.strptime(date2, "%Y-%m-%d %H:%M:%S"))
                    if time2 > time1 :
                        update2=True
                if infodate=="":
                    update3=True
                else :
                    time1=time.mktime(time.strptime(infodate, "%Y-%m-%d %H:%M:%S"))
                    time2=time.mktime(time.strptime(date3, "%Y-%m-%d %H:%M:%S"))
                    if time2 > time1 :
                        update3=True
                if progdate=="":
                    update4=True
                else :
                    time1=time.mktime(time.strptime(progdate, "%Y-%m-%d %H:%M:%S"))
                    time2=time.mktime(time.strptime(date4, "%Y-%m-%d %H:%M:%S"))
                    if time2 > time1 :
                        update4=True
                        
                #print(gbr1)
                if update1 :
                    if gbr1=="" :
                        self.imageBGHome=self.imageBG
                    else :
                        urlname1="http://omegasoft.co.id/images/"+gbr1                
                        print("Get image bg home "+urlname1)
                        Picture_request = requests.get(urlname1)
                        with open(dirgbr1, "wb") as f:
                            f.write(Picture_request.content)
                        self.imageBGHome=dirgbr1
                #print(gbr2)
                if update2 :
                    if gbr2=="" :
                        self.imageBGQR=self.imageBG
                    else :
                        urlname2="http://omegasoft.co.id/images/"+gbr2                
                        print("Get image bg qr "+urlname2)
                        Picture_request = requests.get(urlname2)
                        with open(dirgbr2, "wb") as f:
                            f.write(Picture_request.content)
                        self.imageBGQR=dirgbr2
                #print(gbr3)
                if update3 :
                    if gbr3=="" :
                        self.imageBGInfo=self.imageBG
                    else :
                        urlname3="http://omegasoft.co.id/images/"+gbr3                
                        print("Get image bg info "+urlname3)
                        Picture_request = requests.get(urlname3)
                        with open(dirgbr3, "wb") as f:
                            f.write(Picture_request.content)
                        self.imageBGInfo=dirgbr3
                #print(gbr4)
                if update4 :
                    if gbr4=="" :
                        self.imageBGprogress=self.imageBG
                    else :
                        urlname4="http://omegasoft.co.id/images/"+gbr4                
                        print("Get image bg progress "+urlname4)
                        Picture_request = requests.get(urlname4)
                        with open(dirgbr4, "wb") as f:
                            f.write(Picture_request.content)
                        self.imageBGprogress=dirgbr4
                if update1 or update2 or update3 or update4 :
                    print("update BGData.txt")
                    bgFile = open("/home/pi/Documents/OmegaSanitizer/BGData.txt", "w+") 
                    bgFile.write("BGDate="+date1+"\n")
                    bgFile.write("QRDate="+date2+"\n")
                    bgFile.write("InfoDate="+date3+"\n")
                    bgFile.write("ProgDate="+date4+"\n")
                if CheckFile("/home/pi/Documents/OmegaSanitizer/BGData.txt"):
                    self.imageBGHome=dirgbr1
                    self.imageBGQR=dirgbr2
                    self.imageBGInfo=dirgbr3
                    self.imageBGprogress=dirgbr4
                self.lblBG.setPixmap(QtGui.QPixmap(self.imageBGHome))
                self.lblRefreshInfo.setText("Refreshing BG Image 2 Success")
                self.RefreshInfoBtn.show()
            else :
                print("No BG in db")
                self.RefreshInfoBtn.show()                
        except Exception as e :
            print(e.__class__.__name__)
            self.lblRefreshInfo.setText("Refreshing BG Image 2 Error")
            self.RefreshInfoBtn.show()
        self.RefreshBGBtn.setDisabled(False)

        
    def UpdateBGImage(self):
        isnewfile=False
        updatepicture=False
        if CheckFile("/home/pi/Documents/OmegaSanitizer/PictureData.txt") == False:
            isnewfile = True
            updatepicture = True
            linkBG="http://www.omegasoft.co.id/download/IOT/Sanitizer/BGAll.jpg"
            dirBG="/home/pi/Documents/OmegaSanitizer/Img/BGAll.jpg"
        else :
            isnewfile=False
            try :
                print("compare web data and current data")
                imgdatecabang=""
                with open("/home/pi/Documents/OmegaSanitizer/PictureData.txt") as search:
                    for line in search:
                        line=line.rstrip()
                        if "Date=" in line :
                            imgdate=line.replace("Date=","")
                            print("Current Image Date : "+imgdate)
                        elif "Date"+self.Staff[0:5]+"=" in line:
                            imgdatecabang=line.replace("Date"+self.Staff[0:5]+"=", "")
                            print("Current Image Cabang Date : "+imgdatecabang)
                
                webdatecabang=""
                encoding="utf-8"
                data = urlopen("http://www.omegasoft.co.id/download/IOT/Sanitizer/PictureData.txt")
                for line in data :
                    #line=line.rstrip()
                    webline=str(line, encoding)
                    webline=webline.rstrip()
                    if "Date=" in webline :
                        webdate=webline.replace("Date=","")
                        print("Web Image Date : "+webdate)
                    elif "ImgBG=" in webline :
                        linkBG="http://www.omegasoft.co.id/download/IOT/Sanitizer/"+ webline.replace("ImgBG=", "")
                        dirBG="/home/pi/Documents/OmegaSanitizer/Img/"+ webline.replace("ImgBG=", "")
                    elif "Date"+self.Staff[0:5]+"=" in webline:
                        webdatecabang=webline.replace("Date"+self.Staff[0:5]+"=", "")
                        print("Web Image Cabang Date : "+webdatecabang)
                    elif "ImgBG"+self.Staff[0:5] +"=" in webline :
                        linkBGcabang="http://www.omegasoft.co.id/download/IOT/Sanitizer/"+ webline.replace("ImgBG"+self.Staff[0:5]+"=", "")
                        dirBGcabang="/home/pi/Documents/OmegaSanitizer/Img/"+ webline.replace("ImgBG"+self.Staff[0:5]+"=", "")
                    dateimg=time.mktime(time.strptime(imgdate, "%d%b%Y"))
                if webdatecabang!="":
                    if imgdatecabang=="":
                        updatepicture=True
                    else :
                        dateimg=time.mktime(time.strptime(imgdatecabang, "%d%b%Y"))
                    dateweb=time.mktime(time.strptime(webdatecabang, "%d%b%Y"))
                    linkBG=linkBGcabang
                    dirBG=dirBGcabang
                else :
                    dateweb=time.mktime(time.strptime(webdate, "%d%b%Y"))
                
                if webdatecabang!="" and imgdatecabang=="":
                    updatepicture=True
                else :
                    if dateimg < dateweb :
                        updatepicture=True
                    else :
                        updatepicture=False
            except Exception as e :
                print("Gagal pengecekan data image")
                print(e)
                updatepicture=False
                
        if isnewfile :
            try:
                print("cek picture data new")
                param="ImgBG"+self.Staff[0:5]+"="
                print(param)
                linkBGcabang=""
                encoding="utf-8"
                data = urlopen("http://www.omegasoft.co.id/download/IOT/Sanitizer/PictureData.txt")
                for line in data :
                    #line=line.rstrip()
                    webline=str(line, encoding)
                    webline=webline.rstrip()
                    if "ImgBG=" in webline :
                        print(webline)
                        linkBG="http://www.omegasoft.co.id/download/IOT/Sanitizer/"+ webline.replace("ImgBG=", "")
                        dirBG="/home/pi/Documents/OmegaSanitizer/"+ webline.replace("ImgBG=", "")
                    #elif "ImgBG"+self.Staff[0:5] in webline :
                    elif param in webline :    
                        print(webline)
                        linkBGcabang="http://www.omegasoft.co.id/download/IOT/Sanitizer/"+ webline.replace(param, "")
                        dirBGcabang="/home/pi/Documents/OmegaSanitizer/"+ webline.replace(param, "")
                
                print(linkBGcabang)
                if linkBGcabang!="":
                    linkBG=linkBGcabang
                    print(linkBG)
                    dirBG=dirBGcabang
            except Exception as e :
                print("Gagal mengecek file baru")
                print(e)
            
        if updatepicture :
            print("Updating BG Image")
            try :
                print("Get Picture Data")
                url="http://www.omegasoft.co.id/download/IOT/Sanitizer/PictureData.txt"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaSanitizer/PictureData.txt", "wb") as f:
                    f.write(datatowrite)
                print("Get Img BG : "+linkBG)
                Picture_request = requests.get(linkBG)
                with open(dirBG, "wb") as f:
                    f.write(Picture_request.content)            
            except Exception as e :
                print("Gagal Update Picture")
                print(e)
        else:
            print("Not Updating BG Image")
        self.imageBG=dirBG
        self.imageBGHome=dirBG
        self.imageBGQR=dirBG
        self.imageBGInfo=dirBG
        self.imageBGprogress=dirBG
        print(self.imageBG)
        self.lblBG.setPixmap(QtGui.QPixmap(self.imageBG))
    
    def RefreshBGImage(self):
        #self.RefreshBGBtn.setEnabled(False)
        IsError=False
        print("Start Refresh BG Image")
        if CheckFile("/home/pi/Documents/OmegaSanitizer/PictureData.txt") == False:
            try :
                print("Get Picture Data")
                url="http://www.omegasoft.co.id/download/IOT/Sanitizer/PictureData.txt"
                filedata=urlopen(url)
                datatowrite=filedata.read()
                with open("/home/pi/Documents/OmegaSanitizer/PictureData.txt", "wb") as f:
                    f.write(datatowrite)           
            except Exception as e :
                print("Gagal Get Picture Data "+ e.__class__.__name__)
                isError=True
        filebg=""
        filebgcabang=""
        with open("/home/pi/Documents/OmegaSanitizer/PictureData.txt") as search:
            for line in search:
                line=line.rstrip()
                if "ImgBG=" in line :
                    filebg=line.replace("ImgBG=","")
                    print("BG Image : "+filebg)
                elif "ImgBG"+self.Staff[0:5]+"=" in line:
                    filebgcabang=line.replace("ImgBG"+self.Staff[0:5]+"=", "")
                    print("BG Image Cabang : "+filebgcabang)
        if filebgcabang!="" :
            linkBG="http://www.omegasoft.co.id/download/IOT/Sanitizer/"+filebgcabang
            dirBG="/home/pi/Documents/OmegaSanitizer/"+filebgcabang
            isError=False
        elif filebg!="" :
            linkBG="http://www.omegasoft.co.id/download/IOT/Sanitizer/"+filebg
            dirBG="/home/pi/Documents/OmegaSanitizer/"+filebg
            isError=False
        else :
            isError=True
        if isError==False : 
            try :
                print("Get Img BG : "+linkBG)
                Picture_request = requests.get(linkBG)
                with open(dirBG, "wb") as f:
                    f.write(Picture_request.content)                
                self.imageBG=dirBG
                self.imageBGHome=dirBG
                self.imageBGQR=dirBG
                self.imageBGInfo=dirBG
                self.imageBGprogress=dirBG
                print(self.imageBG)
                self.lblBG.setPixmap(QtGui.QPixmap(self.imageBG))
                self.lblRefreshInfo.setText("Refreshing BG Image Success")
            except Exception as e :
                print("Gagal Get Img BG "+ e.__class__.__name__)
                self.lblRefreshInfo.setText("Refreshing BG Image Failed")
        else:
            print("Gagal Refresh")
            self.lblRefreshInfo.setText("Refreshing BG Image Error")
                
    def UpdateButtonImage(self):
        dirname1="/home/pi/Documents/OmegaSanitizer/Img/Menu1.jpg"
        dirname2="/home/pi/Documents/OmegaSanitizer/Img/Menu2.jpg"
        dirname3="/home/pi/Documents/OmegaSanitizer/Img/Menu3.jpg"
        dirnametemp="/home/pi/Documents/OmegaSanitizer/Img/TempButton.jpg"
        try:
            print("call api refresh image")
            r=requests.post("http://api-prod.omegasoft.co.id/v2/payment/iot-omega/gambar", data={'token':'ojdhKKlhdbsmd2345djjshdjsdhjhjjfsf', 'UID':'2308jdhjhsjshfJJkshdkwrvsuonzMMh', 'gambar1':self.Kode1, 'gambar2':self.Kode2, 'gambar3':self.Kode3})
            result=json.loads(r.text)
            #print(result)
            if result.get("error")==False:
                filename1=result.get("data")[0]["Gambar"]
                filename2=result.get("data")[1]["Gambar"]
                filename3=result.get("data")[2]["Gambar"]
                if filename1==None or filename1=="" :
                    dirname1=dirnametemp
                    urlname1="http://www.omegasoft.co.id/download/IOT/Sanitizer/TempButton.jpg"
                else:
                    urlname1="http://omegasoft.co.id/images/"+filename1 
                if filename2==None or filename2=="" :
                    dirname2=dirnametemp
                    urlname2="http://www.omegasoft.co.id/download/IOT/Sanitizer/TempButton.jpg"
                else:
                    urlname2="http://omegasoft.co.id/images/"+filename2
                if filename3==None or filename3=="" :
                    dirname3=dirnametemp
                    urlname3="http://www.omegasoft.co.id/download/IOT/Sanitizer/TempButton.jpg"
                else:
                    urlname3="http://omegasoft.co.id/images/"+filename3 
                print("Get image button1 "+urlname1)
                Picture_request = requests.get(urlname1)
                with open(dirname1, "wb") as f:
                    f.write(Picture_request.content)
                #if CheckFile(dirname2)==False :
                print("Get image button2 "+urlname2) 
                Picture_request = requests.get(urlname2)
                with open(dirname2, "wb") as f:
                    f.write(Picture_request.content)
                #if CheckFile(dirname3)==False :
                print("Get image button3 "+urlname3)
                Picture_request = requests.get(urlname3)
                with open(dirname3, "wb") as f:
                    f.write(Picture_request.content)
                print("api refresh image success")
                self.lblRefreshInfo.setText("Refreshing Menu Image Success")
                self.RefreshInfoBtn.show()
            elif result.get("error")==False:
                print(result.get("message"))
                self.lblRefreshInfo.setText("Refreshing Menu Image Error \n"+result.get("message"))
                self.RefreshInfoBtn.show()
        except Exception as e :
            print("api refresh image gagal "+ e.__class__.__name__)
            self.lblRefreshInfo.setText("Refreshing Menu Image Failed")
            self.RefreshInfoBtn.show()
        self.Menu1ImgBtn.setIcon(QtGui.QIcon(dirname1))
        self.Menu2ImgBtn.setIcon(QtGui.QIcon(dirname2))
        self.Menu3ImgBtn.setIcon(QtGui.QIcon(dirname3))
        if self.frameSetting.isVisible :
            self.RefreshImgBtn.setDisabled(False)
            
    def TimerRefreshInfoOn(self):
        if self.q==1:
            if self.RefreshType=="Menu":
                self.UpdateMenuPrice()
                #self.UpdateButtonImage()
            if self.RefreshType=="BG" :
                self.RefreshBGImage()
        elif self.q==2:
            if self.RefreshType=="Menu":
                self.UpdateButtonImage()
            if self.RefreshType=="BG" :
                self.UpdateBGImage2()
            self.TimerRefreshInfo.stop()
        self.q+=1
        
    def TimerSendActOn(self):
        if self.r%300==0:
            if self.Staff!="":
                print("api send staff act "+self.Staff)
                coba=0
                while coba<=3 :
                    hasil=Api.SendAct(self.Staff)
                    print(hasil)
                    if hasil=="Success":
                        coba = 4
                        print("success send staff act "+self.Staff)
                    else :
                        coba+=1
        self.r+=1
            
    def RefreshImageBtnClicked(self):
        self.RefreshImgBtn.setEnabled(False)
        self.RefreshType="Menu"
        self.lblRefreshInfo.setText("Refreshing Menu Image\nPlease Wait...")
        self.RefreshInfoBtn.hide() 
        self.frameRefreshInfo.show()
        self.q=0
        self.TimerRefreshInfo.start()
        
    def RefreshBGBtnClicked(self):
        self.RefreshBGBtn.setEnabled(False)
        self.RefreshType="BG"
        self.lblRefreshInfo.setText("Refreshing Background Image\nPlease Wait...")
        self.RefreshInfoBtn.hide() 
        self.frameRefreshInfo.show()
        self.q=0
        self.TimerRefreshInfo.start()
        
    def CloseRefreshInfo(self):
        self.RefreshType=""
        self.TimerRefreshInfo.stop()
        self.frameRefreshInfo.hide()
        
    def UpdateMenuPrice(self):
        cek=False
        hasilcek1, harga1, satuan1 = Api.CekStoknStaff(self.Staff, self.Kode1, 1)
        if hasilcek1!="Terjadi Kesalahan":
            #print(harga1)
            self.lblPrice1.setText("Rp "+str(harga1))
        else :
            self.lblPrice1.setText("Rp -")
            #self.lblRefreshInfo.setText("Refreshing Menu Price Failed")
            cek=True
        hasilcek2, harga2, satuan2 = Api.CekStoknStaff(self.Staff, self.Kode2, 1)
        if hasilcek2!="Terjadi Kesalahan":
            #print(harga2)
            self.lblPrice2.setText("Rp "+str(harga2))
        else :
            self.lblPrice2.setText("Rp -")
            #self.lblRefreshInfo.setText("Refreshing Menu Price Failed")
            cek=True
        hasilcek3, harga3, satuan3 = Api.CekStoknStaff(self.Staff, self.Kode3, 1)
        if hasilcek3!="Terjadi Kesalahan":
            #print(harga3)
            self.lblPrice3.setText("Rp "+str(harga3))
        else :
            self.lblPrice3.setText("Rp -")
            #self.lblRefreshInfo.setText("Refreshing Menu Price Failed")
            cek=True
        if cek==True:            
            self.lblRefreshInfo.setText("Refreshing Menu Price Failed")
        else :
            self.lblRefreshInfo.setText("Refreshing Menu Price Success")
        
        
    def InternetBtnClicked(self):
        vis = self.frameLogin.isVisible()
        if vis:
            self.frameLogin.hide()
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.frameKeyboard.hide()
            if self.IsInternetClicked==True:
                self.IsInternetClicked=False    
        else :
            self.IsInternetClicked=True
            self.frameLogin.show()
            self.lineUserID.setFocus()
            self.frameKeyboard.show()
            self.frameLogin.raise_()
            self.frameKeyboard.raise_()
            self.TimerAutoBack.start()
        #Dialog.showMinimized()
        
    def TimerInternetOn(self):
        #print(self.k)
        hostname="www.telkom.co.id"
        if self.k%60==0:
            speedtest = pyspeedtest.SpeedTest(hostname)
            try :
                ping = speedtest.ping()
                ping = int(ping)
                checkinternet=True
            except :
                ping = 10000
                checkinternet=False
            print("ping "+str(ping))
            if checkinternet==True:            
                self.InternetBtn.setStyleSheet("QPushButton {background-color: green; color: white; border: none}")
            else :
                self.InternetBtn.setStyleSheet("QPushButton {background-color: red; color: white; border: none}")
            
            self.lblInternetSpeed.setText(str(ping)+" ms")
            if ping <=50:
                strRange="100%"
            elif ping >50 and ping <=100:
                strRange="75%"
            elif ping >100 and ping <=200:
                strRange="50%"
            elif ping >200 and ping <=300:
                strRange="25%"
            elif ping >300 :
                strRange="0%"
            self.lblInternetPercent.setText(strRange)
        self.k+=1
    
    def TimerProgressOn(self):
        if self.l==0 :
            #if self.MenuSelected==self.Kode1 and self.varTime1.isnumeric()==False:
                #self.frameProgress.hide()
                #self.lblInformation.setText("Ada kesalahan pada setting time 1")
                #self.GoToInfo()
                #self.frameInformation.show()
                #self.TimerProgress.stop()            
            #elif self.MenuSelected==self.Kode2 and self.varTime2.isnumeric()==False:
                #self.frameProgress.hide()
                #self.lblInformation.setText("Ada kesalahan pada setting time 2")
                #self.GoToInfo()
                #self.frameInformation.show()
                #self.TimerProgress.stop()
            #elif self.MenuSelected==self.Kode3 and self.varTime3.isnumeric()==False:
                #self.frameProgress.hide()
                #self.lblInformation.setText("Ada kesalahan pada setting time 3")
                #self.GoToInfo()
                #self.frameInformation.show()
                #self.TimerProgress.stop()
            self.GoToProgress()
            if self.frameMenu.isVisible() :
                #self.MenuSelected=self.Kode1
                self.frameMenu.hide()
                #self.lblMainTitle.hide()
                print(self.MenuSelected)
                if self.MenuSelected==self.Kode1 :
                    txtCaption=self.Caption1
                elif self.MenuSelected==self.Kode2 :
                    txtCaption=self.Caption2
                elif self.MenuSelected==self.Kode3 :
                    txtCaption=self.Caption3
                if len(txtCaption)>15 :
                    self.lblMenuSelected.setText(str(self.OrderQty)+" cup "+txtCaption[:15]+"...")
                else :
                    self.lblMenuSelected.setText(str(self.OrderQty)+" cup "+txtCaption)
                if self.TypePay=="Multi":
                    txtLabel1="Mengambil Mode Pembayaran."
                    txtLabel2="Mohon tunggu.."
                elif self.TypePay=="Single":               
                    txtLabel1="Mengambil Kode QR."
                    txtLabel2="Mohon tunggu.."
                    self.PaySelected="Shopee"
                self.lblInfoProgress.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                self.frameProgress.show()
            elif self.framePayment2.isVisible():                 
                txtLabel1="Mengambil Kode QR."
                txtLabel2="Mohon tunggu.."
                self.lblInfoProgress.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                self.framePayment2.hide()
                self.frameProgress.show()
                print(self.PaySelected)
        elif self.l==1 :                
            if "Mengambil Mode Pembayaran" in self.lblInfoProgress.text():
                self.CekStoknStaff()
                self.TimerProgress.stop()
            elif "Mengambil Kode QR" in self.lblInfoProgress.text() :
                self.payCancel=False
                self.TimerInternet.stop()
                print("Stop timer Internet sebelum create QR")
                if self.TypePay=="Multi":
                    self.TrxId, urlqr, qrraw = Api.CreatePayment(self.Staff, self.MenuSelected, self.OrderQty, self.PaySelected)
                    print("TrxId : "+self.TrxId + " , url : "+ urlqr )#+ " , qrraw : "+qrraw)
                    if self.TrxId == "Terjadi Kesalahan" : #and urlqr == "Terjadi Kesalahan":
                        self.frameProgress.hide()              
                        txtLabel1=urlqr
                        txtLabel2="Silahkan coba lagi"
                        self.lblInformation.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                        self.GoToInfo()
                        self.frameInformation.show()
                    else :
                        self.frameProgress.hide()
                        self.GoToQR()
                        self.webMultiQR.setUrl(QtCore.QUrl(urlqr))
                        self.CancelMultiPaymentBtn.show()
                        self.frameMultiPayment.show()
                        self.frameMultiPayment.raise_()
                        cursor=QtGui.QCursor()
                        print(cursor.pos())
                        cursor.setPos(0,0)
                        self.i=0
                        self.payCancel=False
                        self.TimerPay.start()
                        #filelog=open(self.fileLogTrans, "a+")
                        #filelog.write(datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" "+self.TrxId+"\r\n")
                elif self.TypePay=="Single":
                    self.CekStoknStaff()
            self.TimerProgress.stop()
        self.l+=1
        
    def NumPadClicked(self, index):
        widgetname=QtWidgets.QApplication.focusWidget().objectName()
        linetext=QtWidgets.QApplication.focusWidget()
        if widgetname=="lineQtyWater" or widgetname=="lineQtyCup" or widgetname=="lineQtyMenu1" or widgetname=="lineQtyMenu2" or widgetname=="lineQtyMenu3":
            numkey=self.ArrNumPad[index]
            if numkey=="CE":
                linetext.clear()
            elif numkey=="C":
                linetext.backspace()
            else:
                linetext.setText(linetext.text()+self.ArrNumPad[index])
            
    def KeyboardClicked(self, index):
        widgetname=QtWidgets.QApplication.focusWidget().objectName()
        linetext=QtWidgets.QApplication.focusWidget()
        if widgetname=="lineUserID" or widgetname=="linePassword" or widgetname=="lineStaff" or widgetname=="lineKode1" or widgetname=="lineKode2" or widgetname=="lineKode3" or widgetname=="lineCaption1" or widgetname=="lineCaption2" or widgetname=="lineCaption3" or widgetname=="lineTime1" or widgetname=="lineTime2" or widgetname=="lineTime3":
            if self.CapsOn==True :
                keyboard=self.buttons2[index]
            else :
                keyboard=self.buttons[index]
            if keyboard=="Space":
                linetext.setText(linetext.text()+" ")
            elif keyboard=="Ent":
                #print("press Enter")
                if widgetname=="lineUserID" or widgetname=="linePassword":
                    self.LoginClicked()
                elif widgetname=="lineStaff" or widgetname=="lineKode1" or widgetname=="lineKode2" or widgetname=="lineKode3" or widgetname=="lineCaption1" or widgetname=="lineCaption2" or widgetname=="lineCaption3":
                    self.SaveSettingClicked()                
            elif keyboard=="Alt":
                print("press Alt")
            elif keyboard=="Ctrl":
                #print("press Ctrl")
                self.CtrlOn= not self.CtrlOn
            elif keyboard=="Shft":
                #print("press Shft")
                self.ShiftOn = not self.ShiftOn
                self.CapsOn = not self.CapsOn
                self.RedrawKeyboard()
            elif keyboard=="Tab":
                #print("press Tab")
                if widgetname=="lineUserID":
                    self.linePassword.setFocus()
                elif widgetname=="linePassword":
                    self.lineUserID.setFocus()
                elif widgetname=="lineStaff":
                    self.lineKode1.setFocus()
                elif widgetname=="lineKode1":
                    self.lineCaption1.setFocus()
                elif widgetname=="lineCaption1":
                    self.lineTime1.setFocus()
                elif widgetname=="lineTime1":
                    self.lineKode2.setFocus()
                elif widgetname=="lineKode2":
                    self.lineCaption2.setFocus()
                elif widgetname=="lineCaption2":
                    self.lineTime2.setFocus()
                elif widgetname=="lineTime2":
                    self.lineKode3.setFocus()
                elif widgetname=="lineKode3":
                    self.lineCaption3.setFocus()
                elif widgetname=="lineCaption3":
                    self.lineTime3.setFocus()
                elif widgetname=="lineTime3":
                    self.lineStaff.setFocus()
            elif keyboard=="Caps":
                #print("press Caps")
                self.CapsOn = not self.CapsOn
                self.RedrawKeyboard()
            elif keyboard=="<-":
                linetext.backspace()
            else :
                if self.CtrlOn==True:
                    if (keyboard=="c") or (keyboard=="C"):
                        linetext.copy()
                    elif keyboard=="x" or keyboard=="X":
                        linetext.cut()
                    elif keyboard=="v" or keyboard=="V":
                        linetext.paste()
                    self.CtrlOn=False
                else :
                    if (self.CapsOn==True) :
                        linetext.setText(linetext.text()+self.buttons2[index])
                    else :
                        linetext.setText(linetext.text()+self.buttons[index])
                    if self.ShiftOn :
                        self.ShiftOn=not self.ShiftOn
                        self.CapsOn=not self.CapsOn
                        self.RedrawKeyboard()
    
    def RedrawKeyboard(self):        
        for x in range(len(self.buttons)) :
            #btn=self.btn[x]
            if (self.CapsOn==True) :
                txtKey=self.buttons2[x]
            else :
                txtKey=self.buttons[x]
            self.btn[x].setText(txtKey)
            
    def RedrawPayment(self):
        for y in range(6):
            if y > len(self.ModePay)-1:
                self.btnPay[y].hide()
            else:
                self.btnPay[y].setText(self.ModePay[y])
                #print(self.ModePay[y])
                if len(self.ModePay)>3:
                    if len(self.ModePay)%2==0:
                        self.btnPay[y].setGeometry(QtCore.QRect((200+y//2*317), (2+y%2*150), 307, 146))
                        #self.btnPay[y].setGeometry(QtCore.QRect((2+y//2*512), (2+y%2*150), 508, 146))
                    else :
                        self.btnPay[y].setGeometry(QtCore.QRect((200+y//3*317), (2+y%3*100), 307, 106))
                        #self.btnPay[y].setGeometry(QtCore.QRect((2+y//3*512), (2+y%3*100), 508, 106))
                else :
                    if len(self.ModePay)%2==0:
                        self.btnPay[y].setGeometry(QtCore.QRect(200, (2+y%2*150), 624, 146))
                        #self.btnPay[y].setGeometry(QtCore.QRect(2, (2+y%2*150), 1020, 146))
                    else :
                        self.btnPay[y].setGeometry(QtCore.QRect(200, (2+y%3*(300//len(self.ModePay))), 624, 300//len(self.ModePay)-4))                
                        #self.btnPay[y].setGeometry(QtCore.QRect(2, (2+y%3*(300//len(self.ModePay))), 1020, 300//len(self.ModePay)-4))                
                self.btnPay[y].show()
                        
                #self.btnPay[y].setGeometry(QtCore.QRect((2+y//3*512), (2+y%3*120), 508, 116))    
        
    def LogoClicked(self):
        vis = self.frameLogin.isVisible()
        if vis:
            self.frameLogin.hide()
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.frameKeyboard.hide()
            if self.IsInternetClicked==True:
                self.IsInternetClicked=False
            self.TimerAutoBack.stop()
            self.o=0
        else :
            self.frameLogin.show()
            self.lineUserID.setFocus()
            self.frameKeyboard.show()
            self.frameLogin.raise_()
            self.frameKeyboard.raise_()
            self.TimerAutoBack.start()
    
    def LoginClicked(self):
        inputuserid=self.lineUserID.text()
        inputuserid=inputuserid.rstrip("\n")
        inputpass=self.linePassword.text()
        inputpass=inputpass.rstrip("\n")
        self.TimerAutoBack.stop()
        #if self.lineUserID.text() == self.UserID and self.linePassword.text() == self.Password :
        if inputuserid == self.UserID and inputpass == self.Password :
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.frameLogin.hide()
            if self.IsInternetClicked==True:
                self.frameKeyboard.hide()  
                self.IsInternetClicked=False
                Dialog.showMinimized()
            else :
                #self.frameSetting.move(820,10)
                self.lineStaff.setText(self.Staff)
                self.lineKode1.setText(self.Kode1)
                self.lineKode2.setText(self.Kode2)
                self.lineKode3.setText(self.Kode3)
                self.lineCaption1.setText(self.Caption1)
                self.lineCaption2.setText(self.Caption2)
                self.lineCaption3.setText(self.Caption3)
                self.lineTime1.setText(self.varTime1)
                self.lineTime2.setText(self.varTime2)
                self.lineTime3.setText(self.varTime3)
                if self.TypePay=="Single":
                    self.GBSingle.setChecked(True)
                else :
                    self.GBMulti.setChecked(True)
                self.lineStaff.setFocus()
                self.frameSetting.show()
        else :
            self.lineUserID.setText("")
            self.linePassword.setText("")
            self.o=0
            self.TimerAutoBack.start()
            
    def DailyClicked(self):
        self.StepCount=1
        self.HelpSelected="Daily"
        self.WebStepSelected=self.WebStepDaily
        #self.webHelp.setUrl(QtCore.QUrl(self.WebStepDaily[self.StepCount -1]))
        self.webHelp.setUrl(QtCore.QUrl(self.WebStepSelected[self.StepCount -1]))
        self.webHelp.show()
        self.lblStep.setText("Step - "+ str(self.StepCount))
        self.frameHelp.show()
        self.frameHelp.raise_()
        
    def WeeklyClicked(self):
        self.StepCount=1
        self.HelpSelected="Weekly"
        self.WebStepSelected=self.WebStepWeekly
        #self.webHelp.setUrl(QtCore.QUrl(self.WebStepDaily[self.StepCount -1]))
        self.webHelp.setUrl(QtCore.QUrl(self.WebStepSelected[self.StepCount -1]))
        self.webHelp.show()
        self.lblStep.setText("Step - "+ str(self.StepCount))
        self.frameHelp.show()
        self.frameHelp.raise_()
        
        
    def NextHelpClicked(self):
        print(self.StepCount)
        self.StepCount+=1
        print(self.StepCount)
        if self.StepCount<=len(self.WebStepSelected):
            self.webHelp.setUrl(QtCore.QUrl(self.WebStepSelected[self.StepCount -1]))
            self.lblStep.setText("Step - "+ str(self.StepCount))
            self.NextHelpBtn.setText("Next")
            #if self.StepCount==3:
                #self.NextHelpBtn.setText("Exit")
            #else :
               #self.NextHelpBtn.setText("Next")
        elif self.StepCount==len(self.WebStepSelected)+1:
            self.BackToSettingBtn.hide()
            self.NextStepBtn2.show()
            self.frameIngredientSetting.show()
            self.frameIngredientSetting.raise_()
        elif self.StepCount==len(self.WebStepSelected)+2:
            self.lblStep.setText("Step - "+ str(self.StepCount))
            self.webHelp.hide()
            self.lblTimerCD.show()
            self.NextHelpBtn.hide()
            self.m=600
            self.TimerCD.start()
        else :
            self.frameHelp.hide()
            self.CancelSettingClicked()
            
    def TimerCDOn(self):
        self.m-=1
        self.lblTimerCD.setText("Mohon tunggu..\n"+str(self.m//60).zfill(2)+":"+str(self.m%60).zfill(2))
        if self.m==0:
            self.lblTimerCD.setText("Selesai.\n"+str(self.m//60).zfill(2)+":"+str(self.m%60).zfill(2))
            self.StepCount+=1
            self.NextHelpBtn.show()
            self.NextHelpBtn.setText("Finish")
            self.TimerCD.stop()
            
    def TimerAutoBackOn(self):
        self.o+=1
        self.lblInfoCD.show()
        self.lblInfoCD2.show()
        if self.o<15:
            self.lblInfoCD.setText("Mohon Tunggu\n"+str(15- self.o))
            self.lblInfoCD2.setText("Mohon Tunggu\n"+str(15- self.o))    
        elif self.o==15:
            self.frameInformation.hide()
            self.frameInformation2.hide()
            self.lblInfoCD.setText("")
            self.lblInfoCD2.setText("")
            self.lblInfoCD.hide()
            self.lblInfoCD2.hide()
            self.lblMenu1Btn.hide()
            self.lblMenu2Btn.hide()
            self.lblMenu3Btn.hide()
            self.framePayment.hide()
            self.framePayment2.hide()
            self.frameSinglePayment.hide()
            if self.frameLogin.isVisible() :
                self.frameLogin.hide()
                self.lineUserID.setText("")
                self.linePassword.setText("")
                self.frameKeyboard.hide()
                if self.IsInternetClicked==True:
                    self.IsInternetClicked=False  
            #self.LogoClicked()
            self.frameKeyboard.hide()
            self.webView.hide()
            self.GoToMainMenu()
            self.frameMenu.show()
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.OrderQty = 1
            self.lblQty.setText("1")
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            #self.lblMainTitle.show()
            self.o=0
            self.TimerAutoBack.stop()
            
        
    def SaveSettingClicked(self):
        settingFile = open(self.fileSettingBackup, "w+") 
        settingFile.write("Staff : "+self.lineStaff.text()+"\n")
        settingFile.write("Kode1 : "+self.lineKode1.text()+"\n")
        settingFile.write("Caption1 : "+self.lineCaption1.text()+"\n")
        settingFile.write("Time1 : "+self.lineTime1.text()+"\n")
        settingFile.write("Kode2 : "+self.lineKode2.text()+"\n")
        settingFile.write("Caption2 : "+self.lineCaption2.text()+"\n")
        settingFile.write("Time2 : "+self.lineTime2.text()+"\n")
        settingFile.write("Kode3 : "+self.lineKode3.text()+"\n")
        settingFile.write("Caption3 : "+self.lineCaption3.text()+"\n")
        settingFile.write("Time3 : "+self.lineTime3.text()+"\n")
        if self.GBSingle.isChecked() :
            settingFile.write("TypePay : Single")
            self.TypePay="Single"
        elif self.GBMulti.isChecked() :
            settingFile.write("TypePay : Multi")
            self.TypePay="Multi"        
        
        settingFile = open(self.fileSetting, "w+") 
        settingFile.write("Staff : "+self.lineStaff.text()+"\n")
        settingFile.write("Kode1 : "+self.lineKode1.text()+"\n")
        settingFile.write("Caption1 : "+self.lineCaption1.text()+"\n")
        settingFile.write("Time1 : "+self.lineTime1.text()+"\n")
        settingFile.write("Kode2 : "+self.lineKode2.text()+"\n")
        settingFile.write("Caption2 : "+self.lineCaption2.text()+"\n")
        settingFile.write("Time2 : "+self.lineTime2.text()+"\n")
        settingFile.write("Kode3 : "+self.lineKode3.text()+"\n")
        settingFile.write("Caption3 : "+self.lineCaption3.text()+"\n")
        settingFile.write("Time3 : "+self.lineTime3.text()+"\n")
        if self.GBSingle.isChecked() :
            settingFile.write("TypePay : Single")
            self.TypePay="Single"
        elif self.GBMulti.isChecked() :
            settingFile.write("TypePay : Multi")
            self.TypePay="Multi"
        
        self.Staff = self.lineStaff.text()
        self.Staff = self.Staff.rstrip("\r\n")
        self.Kode1 = self.lineKode1.text()
        self.Kode1 = self.Kode1.rstrip("\r\n")
        self.Kode2 = self.lineKode2.text()
        self.Kode2 = self.Kode2.rstrip("\r\n")
        self.Kode3 = self.lineKode3.text()
        self.Kode3 = self.Kode3.rstrip("\r\n")
        self.Caption1 = self.lineCaption1.text()
        self.Caption1 = self.Caption1.rstrip("\r\n")
        self.Caption2 = self.lineCaption2.text()
        self.Caption2 = self.Caption2.rstrip("\r\n")
        self.Caption3 = self.lineCaption3.text()
        self.Caption3 = self.Caption3.rstrip("\r\n")
        self.varTime1 = self.lineTime1.text()
        self.varTime1 = self.varTime1.rstrip("\r\n")
        self.varTime2 = self.lineTime2.text()
        self.varTime2 = self.varTime2.rstrip("\r\n")
        self.varTime3 = self.lineTime3.text()
        self.varTime3 = self.varTime3.rstrip("\r\n")
        if len(self.Caption1)>15 :
            self.Menu1Btn.setText(self.Caption1[:15]+"...")
        else :
            self.Menu1Btn.setText(self.Caption1)
        if len(self.Caption2)>15 :
            self.Menu2Btn.setText(self.Caption2[:15]+"...")
        else :
            self.Menu2Btn.setText(self.Caption2)
        if len(self.Caption3)>15 :
            self.Menu3Btn.setText(self.Caption3[:15]+"...")
        else :
            self.Menu3Btn.setText(self.Caption3)
        self.frameSetting.hide() 
        self.frameKeyboard.hide()
            
    def CancelSettingClicked(self):
        vis = self.frameSetting.isVisible()
        if vis :
            self.frameSetting.hide()
            self.lineStaff.setText("")
            self.lineKode1.setText("")
            self.lineKode2.setText("")
            self.lineKode3.setText("")
            self.lineCaption1.setText("")
            self.lineCaption2.setText("")
            self.lineCaption3.setText("")
            self.lineTime1.setText("")
            self.lineTime2.setText("")
            self.lineTime3.setText("")
            self.frameKeyboard.hide()
            
    def IngredientSettingClicked(self):
        self.BackToSettingBtn.show()
        self.frameIngredientSetting.show()
        self.frameIngredientSetting.raise_()
        
    def BackClicked(self):
        self.frameIngredientSetting.hide()
        
    def NextStepBtn2Clicked(self):
        self.NextHelpClicked()
        self.frameIngredientSetting.hide()
            
    def MenuClick(self):
        if self.varTime1.isnumeric()==False:
            self.lblInformation.setText("Ada kesalahan pada setting time 1")
            self.GoToInfo()
            self.frameMenu.hide()
            self.frameInformation.show()
        else :
            if int(self.varTime1)==0:
                self.lblInformation.setText("Setting time 1 tidak boleh 0")
                self.GoToInfo()
                self.frameMenu.hide()
                self.frameInformation.show()    
            else :
                self.MenuSelected=self.Kode1
                self.lblMenu1Btn.show()
                self.l=0
                self.TimerProgress.start()
                self.TimeRelayStop=int(self.varTime1)
        
    def Menu2Click(self):
        if self.varTime2.isnumeric()==False:
            self.lblInformation.setText("Ada kesalahan pada setting time 2")
            self.GoToInfo()
            self.frameMenu.hide()
            self.frameInformation.show()
        else :
            if int(self.varTime2)==0:
                self.lblInformation.setText("Setting time 2 tidak boleh 0")
                self.GoToInfo()
                self.frameMenu.hide()
                self.frameInformation.show()
            else :
                self.MenuSelected=self.Kode2
                self.lblMenu2Btn.show()
                self.l=0
                self.TimerProgress.start()
                self.TimeRelayStop=int(self.varTime2)
        
    def Menu3Click(self):
        if self.varTime3.isnumeric()==False:
            self.lblInformation.setText("Ada kesalahan pada setting time 3")
            self.GoToInfo()
            self.frameMenu.hide()
            self.frameInformation.show()
        else :
            if int(self.varTime3)==0:
                self.lblInformation.setText("Setting time 3 tidak boleh 0")
                self.GoToInfo()
                self.frameMenu.hide()
                self.frameInformation.show()
            else :
                self.MenuSelected=self.Kode3
                self.lblMenu3Btn.show()
                self.l=0
                self.TimerProgress.start()
                self.TimeRelayStop=int(self.varTime3)
        
    def CekStoknStaff(self):
        hasilcek, cekharga, ceksatuan=Api.CekStoknStaff(self.Staff, self.MenuSelected, self.OrderQty)
        
        print("Hasil cek : "+hasilcek)
        print("Harga : "+cekharga+" satuan "+ceksatuan)
        if hasilcek=="Sukses":
            #self.CekPayment()
            print(self.MenuSelected)
            if self.MenuSelected==self.Kode1 :
                txtCaption=self.Caption1
            elif self.MenuSelected==self.Kode2 :
                txtCaption=self.Caption2
            elif self.MenuSelected==self.Kode3 :
                txtCaption=self.Caption3
            if len(txtCaption)>15 :
                self.lblMenuSelected.setText(str(self.OrderQty)+" "+ceksatuan+" "+txtCaption[:15]+"...")
            else :
                self.lblMenuSelected.setText(str(self.OrderQty)+" "+ceksatuan+" "+txtCaption)                
            totalharga=int(self.OrderQty)*int(cekharga)
            self.lblMenuPrice.setText("Total Rp "+str(totalharga))
            self.lblMenuSelected.show()
            self.lblMenuPrice.show()
            if self.TypePay=="Multi":
                if self.getPaymentMode==True:
                    self.frameProgress.hide()
                    #self.framePayment.show()
                    self.CancelPaymentBtn2.show()
                    self.framePayment2.show()
                else :
                    self.CekPayment()
            elif self.TypePay=="Single":
                print(self.IsSingleQR)
                if self.IsSingleQR==False:
                    trycekpay=0
                    while True:
                        hasiltipe=Api.CekTipePayment(self.Staff)
                        #print("Hasil tipe : "+hasiltipe)
                        if "Terjadi Kesalahan" in hasiltipe:
                            if trycekpay>5:
                                break
                        else :
                            if ("Gopay" in hasiltipe) or ("LinkAja" in hasiltipe) or ("Shopee" in hasiltipe) :
                                if "GoPay" in hasiltipe:
                                    self.ModePay.append("GoPay")
                                if "LinkAja" in hasiltipe:
                                    self.ModePay.append("LinkAja")
                                if "Shopee" in hasiltipe:
                                    self.ModePay.append("Shopee")
                                    self.IsSingleQR=True
                                self.getPaymentMode=True
                            self.RedrawPayment()
                            break            
                        trycekpay+=1
                    if self.IsSingleQR==False:
                        self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
                        self.GoToInfo()
                        self.frameInformation.show()
                        #self.TimerAutoBack.start()
                        self.frameProgress.hide()
                    else :
                        self.TrxId, urlqr, qrraw = Api.CreatePayment(self.Staff, self.MenuSelected, self.OrderQty, self.PaySelected)
                        print("TrxId : "+self.TrxId + " , url : "+ urlqr)#+ " , qrraw : "+qrraw)
                        if self.TrxId == "Terjadi Kesalahan": # and urlqr == "Terjadi Kesalahan":           
                            txtLabel1=urlqr
                            txtLabel2="Silahkan coba lagi"
                            self.lblInformation.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                            self.GoToInfo()
                            self.frameInformation.show()
                            self.frameProgress.hide() 
                        else :
                            self.CancelSinglePaymentBtn.show()
                            self.GoToQR()
                            self.frameSinglePayment.show()
                            self.frameSinglePayment.raise_()
                            cursor=QtGui.QCursor()
                            print(cursor.pos())
                            cursor.setPos(0,0)
                            self.i=0
                            self.payCancel=False
                            self.TimerPay.start()
                            #filelog=open(self.fileLogTrans, "a+")
                            #now=datetime.now()
                            #filelog.write(now.strftime("%d/%m/%Y %H:%M:%S")+" "+self.TrxId+"\r\n")
                            self.frameProgress.hide()  
                else:
                    self.TrxId, urlqr, qrraw = Api.CreatePayment(self.Staff, self.MenuSelected, self.OrderQty, self.PaySelected)
                    print("TrxId : "+self.TrxId + " , url : "+ urlqr)#+ " , qrraw : "+qrraw)
                    if self.TrxId == "Terjadi Kesalahan": # and urlqr == "Terjadi Kesalahan":
                        self.frameProgress.hide()            
                        txtLabel1=urlqr
                        txtLabel2="Silahkan coba lagi"
                        #self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
                        self.lblInformation.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                        self.GoToInfo()
                        self.frameInformation.show()
                        #self.TimerAutoBack.start()
                    else :
                        self.frameProgress.hide()
                        self.webSingleQR.setUrl(QtCore.QUrl(urlqr))
                        self.CancelSinglePaymentBtn.show()
                        self.GoToQR()
                        self.frameSinglePayment.show()
                        self.frameSinglePayment.raise_()
                        cursor=QtGui.QCursor()
                        print(cursor.pos())
                        cursor.setPos(0,0)
                        self.i=0
                        self.payCancel=False
                        self.TimerPay.start()
                        #filelog=open(self.fileLogTrans, "a+")
                        #filelog.write(datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" "+self.TrxId+"\r\n")
        else :
            self.frameProgress.hide()
            if hasilcek=="Error Stok":
                self.lblInformation.setText("Maaf, pilihan Anda tidak tersedia")
            elif hasilcek=="Error Staff":
                self.lblInformation.setText("Staff tidak aktif")
            elif hasilcek=="Terjadi Kesalahan":
                self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
            elif hasilcek=="Timeout":
                self.lblInformation.setText("Timeout")
            self.GoToInfo()
            self.frameInformation.show()
            
    def CekPayment(self):
        self.LaundroMatBtn.hide()
        self.GoPayBtn.hide()
        self.LinkAjaBtn.hide()
        self.ShopeeBtn.hide()
        hasiltipe=Api.CekTipePayment(self.Staff)
        self.ModePay.clear()
        print("Hasil tipe : "+hasiltipe)
        if "Terjadi Kesalahan" in hasiltipe:
            self.lblInformation.setText("Terjadi kesalahan.\nSilahkan coba lagi")
            self.GoToInfo()
            self.frameInformation.show()
        else :
            if "GoPay" in hasiltipe:
                self.GoPayBtn.show()
                self.ModePay.append("GoPay")
            if "LinkAja" in hasiltipe:
                self.LinkAjaBtn.show()
                self.ModePay.append("LinkAja")
            if "Shopee" in hasiltipe:
                self.ModePay.append("Shopee")
                self.IsSingleQR=True
            self.frameProgress.hide()
            self.RedrawPayment()            
            self.CancelPaymentBtn2.show()
            self.framePayment2.show()
    
    def CancelPayment(self):
        vis=self.frameMultiPayment.isVisible()
        vis2=self.frameInformation.isVisible()
        vis3=self.frameQR.isVisible()
        vis4=self.frameSinglePayment.isVisible()
        if vis or vis4 :
            if vis :
                self.CancelPaymentBtn.hide()
                self.CancelPaymentBtn2.hide()
                self.CancelMultiPaymentBtn.hide()
            elif vis4 :
                self.CancelSinglePaymentBtn.hide()
            if self.lblWaitingPayment.isVisible() or self.lblExceptionWarning.isVisible():
                self.lblWaitingPayment.hide()
                #self.lblWaitingPayment.show()
                self.lblExceptionWarning.hide()
            self.lblInfoProgress.setText("Cancelling.\nPlease Wait..")
            self.payCancel=True
            self.tryCancel=0
        elif vis2 :
            self.GoToMainMenu()
            self.frameMenu.show()
            self.framePayment.hide()
            self.framePayment2.hide()
            self.frameInformation.hide()
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.OrderQty = 1
            self.lblQty.setText("1")
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            #self.lblMainTitle.show()
            self.TimerStatus.stop()
            self.CancelSinglePaymentBtn.show()
            self.CancelPaymentBtn.show()
            self.CancelPaymentBtn2.show()
            self.TimerAutoBack.stop()
            self.o=0
        elif vis3 :
            self.GoToProgress()
            self.frameProgress.show()
            self.lblInfoProgress.setText("Cancelling.\nPlease Wait..")
            self.payCancel=True
            self.tryCancel=0
            self.CancelPaymentBtn.hide()
        else :
            self.GoToMainMenu()
            self.frameMenu.show()
            self.framePayment.hide()
            self.framePayment2.hide()
            self.frameSinglePayment.hide()
            self.webView.hide()
            self.frameInformation.hide()
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.OrderQty = 1
            self.lblQty.setText("1")
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            #self.lblMainTitle.show()
            self.CancelSinglePaymentBtn.show()
            self.CancelPaymentBtn.show()
            self.CancelPaymentBtn2.show()
            self.TimerAutoBack.stop()
            self.o=0
        if self.TimerInternet.isActive()==False:
            print("Restart Timer Internet")
            self.TimerInternet.start()
        self.lblMenu1Btn.hide()
        self.lblMenu2Btn.hide()
        self.lblMenu3Btn.hide()
        self.lblInfoCD.setText("")
        self.lblInfoCD2.setText("")
        self.lblInfoCD.hide()
        self.lblInfoCD2.hide()
        DisconnectRelay(self.channel1)
        DisconnectRelay(self.channel2)
        DisconnectRelay(self.channel3)
        DisconnectRelay(self.channel5)
            
    def LinkAjaClicked(self):
        self.PaySelected="LinkAja"
        self.l=0
        self.TimerProgress.start()
    
    def ModePayClicked(self, index):
        print(self.btnPay[index].text())
        self.PaySelected=self.btnPay[index].text()
        self.l=0
        self.TimerProgress.start()
            
    def GoPayClicked(self):
        self.PaySelected="GoPay"
        self.l=0
        self.TimerProgress.start()
        
    def ShopeeClicked(self):
        self.PaySelected="Shopee"
        self.l=0
        self.TimerProgress.start()
    
    def TimerPayOn(self):
        #vis = self.webView.isVisible()
        #self.lblWaitingPayment.setText("Menunggu Pembayaran\n"+str(self.i//60).zfill(2)+":"+str(self.i%60).zfill(2))
        #self.lblInfoTimer.setText(str(self.i//60).zfill(2)+":"+str(self.i%60).zfill(2))
        vis = self.frameMultiPayment.isVisible()
        vis2 = self.frameQR.isVisible()
        vis3 = self.frameSinglePayment.isVisible()
        if self.payCancel :
            print("Cancel ",self.tryCancel)
            self.lblWaitingPayment.setText("Membatalkan Pembelian\nMohonTunggu.")
            self.lblWaitingPayment.show()
            if vis or vis3 :
                if vis :
                    hasilbatal = Api.CancelPayment(self.TrxId, "")
                elif vis3 :
                    hasilbatal = Api.CancelPayment(self.TrxId, "Shopee")
                print("Hasil batal : "+hasilbatal)
                if hasilbatal=="Dibatalkan":
                    hasilrefund=Api.Refund(self.TrxId)
                    print(hasilrefund)
                    self.TrxId=""
                    self.webView.hide()
                    self.frameMultiPayment.hide()
                    self.frameSinglePayment.hide()
                    self.lblWaitingPayment.hide()                    
                    #filelog=open(self.fileLogTrans, "a+")
                    #filelog.write(datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" "+self.TrxId+" dibatalkan\r\n")
                    self.TimerPay.stop()
                    self.frameProgress.hide()
                    #self.payCancel=False
                    self.lblInformation.setText("Pembelian dibatalkan.")
                    self.GoToInfo()
                    self.frameInformation.show()
                    self.TimerAutoBack.start()
                else:
                    if self.tryCancel==3:
                        hasilrefund=Api.Refund(self.TrxId)
                        print(hasilrefund)
                        self.TrxId=""
                        self.webView.hide()
                        self.frameSinglePayment.hide()
                        self.frameMultiPayment.hide()
                        #filelog=open(self.fileLogTrans, "a+")
                        #filelog.write(datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" "+self.TrxId+" dibatalkan\r\n")
                        self.lblWaitingPayment.hide()                    
                        self.TimerPay.stop()
                        self.frameProgress.hide()
                        #self.payCancel=False
                        self.lblInformation.setText("Pembelian dibatalkan")
                        self.GoToInfo()
                        self.frameInformation.show()
                        self.TimerAutoBack.start()
                self.tryCancel+=1
            elif vis2 :
                hasilbatal=Api.CancelPayment(self.TrxId, "Laundromat")
                print("Hasil batal : "+hasilbatal)
                if hasilbatal=="Dibatalkan":
                    self.TimerPay.stop()
                    self.TrxId=""
                    self.frameQR.hide()
                    self.frameProgress.hide()
                    #self.payCancel=False
                    self.lblWaitingPayment.hide()
                    self.lblInformation.setText("Pembelian dibatalkan.")
                    self.GoToInfo()
                    self.frameInformation.show()
                    self.TimerAutoBack.start()
                else:
                    if self.tryCancel==3:
                        self.TimerPay.stop()
                        self.TrxId=""
                        self.webView.hide()
                        self.frameProgress.hide()
                        #self.payCancel=False
                        self.lblWaitingPayment.hide()
                        self.lblInformation.setText("Pembelian dibatalkan.")
                        self.GoToInfo()
                        self.frameInformation.show()
                        self.TimerAutoBack.start()
                self.tryCancel+=1
        else :
            self.lblWaitingPayment.setText("Menunggu Pembayaran\n"+str(self.i//60).zfill(2)+":"+str(self.i%60).zfill(2))
            if self.i % 2 == 0 :
                #if self.i==0:
                    #self.CheckLog()
                print("Menunggu pembayaran ",self.i, " "+self.TrxId)
                if vis :
                    hasilcekstatus=Api.CekPayment(self.TrxId, "")
                elif vis2 :
                    hasilcekstatus=Api.CekPayment(self.TrxId, "Laundromat")
                elif vis3 :
                    hasilcekstatus=Api.CekPayment(self.TrxId, "Shopee")
                print(hasilcekstatus)
                #filelog=open(self.fileLogTrans, "a+")
                #filelog.write(datetime.datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" "+hasilcekstatus+"\r\n")
                if hasilcekstatus=="Terbayar":
                    #filelog=open(self.fileLogTrans, "a+")
                    #filelog.write(datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" Terbayar\r\n")
                    if self.IsException==True:
                        self.IsException=False
                        self.lblExceptionWarning.hide()
                    self.webView.hide()
                    self.frameQR.hide()
                    self.frameSinglePayment.hide()
                    self.frameMultiPayment.hide()
                    self.TrxId=""
                    self.framePayment.hide()
                    self.TimerPay.stop()
                    self.lblWaitingPayment.hide()
                    self.lblExceptionWarning.hide()
                    if self.MenuSelected==self.Kode1:
                        self.TimeRelayStop=int(self.varTime1)
                    elif self.MenuSelected==self.Kode2:
                        self.TimeRelayStop==int(self.varTime2)
                    elif self.MenuSelected==self.Kode3:
                        self.TimeRelayStop==int(self.varTime3)
                    print(self.OrderQty)
                    if self.OrderQty==1 :
                        txtLabel1="Pembelian berhasil."
                        txtLabel2="Mohon tunggu.."
                        self.lblInformation.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                        #self.lblInformation.setText("Pembelian berhasil.")
                        self.GoToInfo()
                        self.frameInformation.show()
                        self.BackToMainBtn.hide()
                        self.j=0
                        self.TimerStatus.start()
                    else :
                        self.OrderQty=self.OrderQty -1
                        if self.OrderQty==0:
                            txtLabel1="Pembelian berhasil."
                            txtLabel2="Mohon tunggu.."
                            self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                            #self.lblInformation2.setText("Pembelian berhasil.\nMohon tunggu..")
                            #self.lblInformation2.setText("Semua cup sudah diambil")
                            self.NextCupBtn.setText("Kembali ke Menu Utama")
                            self.NextCupBtn.hide()
                        else :
                            txtLabel1="Pembelian berhasil."
                            txtLabel2="Mohon tunggu.."
                            self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                            #self.lblInformation2.setText("Pembelian berhasil.\nMohon tunggu..")
                            self.NextCupBtn.setText("Item Berikutnya")
                            self.NextCupBtn.hide()
                            #self.lblInformation2.setText("Pembelian berhasil. Sisa cup : "+ str(self.OrderQty))
                        self.GoToInfo()
                        self.frameInformation2.show()
                        self.j=0
                        self.TimerStatus.start()
                    #self.TimerStatus2()
                elif hasilcekstatus=="Belum":
                    #filelog=open(self.fileLogTrans, "a+")
                    #filelog.write(datetime.datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" Belum\r\n")
                    if not self.payCancel:
                        #filelog=open(self.fileLogTrans, "a+")
                        #filelog.write(datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" Belum\r\n")
                        self.lblWaitingPayment.show()
                        if self.IsException==True:
                            self.IsException=False
                            self.lblExceptionWarning.hide()
                        if self.i>=180 :
                            if self.lblWaitingPayment.isVisible():
                                self.lblWaitingPayment.hide()
                            if vis or vis2 or vis3 :
                                self.CancelPayment()
                    
                            #self.TrxId=""
                            #self.framePayment.hide()
                            #self.frameQR.hide()
                #elif hasilcekstatus=="Terjadi Kesalahan":
                else:
                    #filelog=open(self.fileLogTrans, "a+")
                    #filelog.write(datetime.datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" "+hasilcekstatus+"\r\n")
                    if not self.payCancel:
                        #filelog=open(self.fileLogTrans, "a+")
                        #filelog.write(datetime.now().strftime("%d/%m/%Y %H:%M:%S")+" "+hasilcekstatus+"\r\n")
                        self.IsException = True
                        self.lblExceptionWarning.show()
                        if self.lblWaitingPayment.isVisible():
                            self.lblWaitingPayment.hide()
        self.i+=1
    
    def NextCupClicked(self):
        if self.OrderQty>0:
            self.OrderQty=self.OrderQty -1
            if self.OrderQty==0:
                self.NextCupBtn.setText("Kembali ke Menu Utama")
                txtLbl1="Mohon tunggu.."
                self.lblInformation2.setText("<span style='font-size:50pt'>"+txtLbl1+"</span>")
                self.NextCupBtn.hide()
                #self.lblInformation2.setText("Semua cup sudah diambil")
            else :
                txtLbl1="Mohon tunggu.."
                self.lblInformation2.setText("<span style='font-size:50pt'>"+txtLbl1+"</span>")
                #self.lblInformation2.setText("Mohon tunggu..")
                self.NextCupBtn.setText("Item Berikutnya")
                self.NextCupBtn.hide()
                #self.lblInformation2.setText("Sisa cup yang belum diambil: "+ str(self.OrderQty))
            #self.frameInformation2.show()
            self.j=0
            self.TimerStatus.start()
        else :
            self.frameInformation2.hide()
            self.lblInfoCD2.setText("")
            self.lblMenu1Btn.hide()
            self.lblMenu2Btn.hide()
            self.lblMenu3Btn.hide()
            self.GoToMainMenu()
            self.frameMenu.show()
            self.OrderQty=1
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            #self.lblMainTitle.show()
            self.TimerStatus.stop()
            self.o=0
            self.TimerAutoBack.stop()
               
    def TimerStatusOn(self):
        if self.j==0:
            #ConnectRelay(self.channel1)
            #print("Masukkan uang")
            #time.sleep(1)
            #DisconnectRelay(self.channel1)
        #elif self.j==2:
            #DisconnectRelay(self.channel1)
            #print("Selesai masukkan uang")
        #elif self.j==3:
            ConnectRelay(self.channel5)
            if self.MenuSelected==self.Kode1:
                ConnectRelay(self.channel1)
                print("tekan menu1")
            elif self.MenuSelected==self.Kode2:
                ConnectRelay(self.channel2)
                print("tekan menu2")
            elif self.MenuSelected==self.Kode3:
                ConnectRelay(self.channel3)
                print("tekan menu3")
            #time.sleep(5)
        #elif self.j==1000:
        elif self.j==self.TimeRelayStop:
            DisconnectRelay(self.channel5)
            if self.MenuSelected==self.Kode1:
                DisconnectRelay(self.channel1)
            elif self.MenuSelected==self.Kode2:
                DisconnectRelay(self.channel2)
            elif self.MenuSelected==self.Kode3:
                DisconnectRelay(self.channel3)
            #self.MenuSelected=""
        #elif self.j==3000:
        elif self.j==self.TimeRelayStop+10:
            DisconnectRelay(self.channel5)
            if self.MenuSelected==self.Kode1:
                DisconnectRelay(self.channel1)
            elif self.MenuSelected==self.Kode2:
                DisconnectRelay(self.channel2)
            elif self.MenuSelected==self.Kode3:
                DisconnectRelay(self.channel3)
            vis = self.frameInformation.isVisible()
            vis2 = self.frameInformation2.isVisible()
            if vis :
                txtLabel1="Silahkan ambil."
                txtLabel1=""
                txtLabel2="Terimakasih."
                self.lblInformation.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                #self.lblInformation.setText("Silahkan ambil cup.\nTerimakasih.")       
                self.BackToMainBtn.show()
                self.TimerStatus.stop()
                self.TimerAutoBack.start()
            elif vis2 :
                if self.OrderQty == 0 :
                    txtLabel1="Semua item sudah diambil."
                    txtLabel2="Terimakasih."
                    self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                    #self.lblInformation2.setText("Semua cup sudah diambil.\nTerimakasih.")derQty)+". \nSilahkan ambil Cup lalu tekan Cup Berikutnya.")
                    self.NextCupBtn.show()
                    self.TimerStatus.stop()
                    self.TimerAutoBack.start()
                else :
                    txtLabel1="Sisa item : "+ str(self.OrderQty)
                    #txtLabel2="Silahkan ambil Cup lalu tekan Cup Berikutnya."
                    txtLabel2="Silahkan ambil dan siapkan botol berikutnya"
                    txtLabel3="Lalu tekan Item Berikutnya"
                    self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:30pt'>"+txtLabel2+"</span><br><span style='font-size:30pt'>"+txtLabel3+"</span>")
                    #self.lblInformation2.setText("Sisa cup : "+ str(self.OrderQty)+". \nSilahkan ambil Cup lalu tekan Cup Berikutnya.")derQty)+". \nSilahkan ambil Cup lalu tekan Cup Berikutnya.")
                    self.NextCupBtn.show()
                    self.TimerStatus.stop()
                #self.NextCupBtn.show()
            #self.TimerStatus.stop()
        #elif self.j==6000:
        elif self.j==self.TimeRelayStop+1500:
            vis = self.frameInformation.isVisible()
            vis2 = self.frameInformation2.isVisible()
            if vis :
                self.frameInformation.hide()
            elif vis2:
                self.frameInformation2.hide()
            self.GoToMainMenu()
            self.frameMenu.show()
            self.framePayment.hide()
            self.webView.hide()
            self.frameInformation.hide()
            self.lblMenuSelected.setText("Pilihan Rasa")
            self.OrderQty = 1
            self.lblMenuSelected.hide()
            self.lblMenuPrice.hide()
            #self.lblMainTitle.show()
            self.TimerStatus.stop()
        self.j+=1
        
    def TimerStatusOctOn(self):
        if self.j==0:
            ConnectRelay(self.channel5)
            print("Masukkan uang")
            #time.sleep(1)
            #DisconnectRelay(self.channel1)
        elif self.j==1:
            DisconnectRelay(self.channel5)
            print("Selesai masukkan uang")
        elif self.j==2:
            if self.MenuSelected==self.Kode1:
                ConnectRelay(self.channel2)
                print("tekan menu1")
            elif self.MenuSelected==self.Kode2:
                ConnectRelay(self.channel3)
                print("tekan menu2")
            elif self.MenuSelected==self.Kode3:
                ConnectRelay(self.channel4)
                print("tekan menu3")
            time.sleep(5)
        elif self.j==5:
            if self.MenuSelected==self.Kode1:
                DisconnectRelay(self.channel2)
            elif self.MenuSelected==self.Kode2:
                DisconnectRelay(self.channel3)
            elif self.MenuSelected==self.Kode3:
                DisconnectRelay(self.channel4)
            #self.MenuSelected=""
            time.sleep(3)
        elif self.j==2000:      
            vis = self.frameInformation.isVisible()
            vis2 = self.frameInformation2.isVisible()
            if vis :
                txtLabel1="Silahkan ambil cup."
                txtLabel2="Terimakasih."
                self.lblInformation.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                #self.lblInformation.setText("Silahkan ambil cup.\nTerimakasih.")
                self.BackToMainBtn.show()
            elif vis2 :
                if self.OrderQty == 0 :
                    txtLabel1="Semua cup sudah diambil."
                    txtLabel2="Terimakasih."
                    self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                    #self.lblInformation2.setText("Semua cup sudah diambil.\nTerimakasih.")
                else :
                    txtLabel1="Sisa cup : "+ str(self.OrderQty)
                    #txtLabel2="Silahkan ambil Cup lalu tekan Cup Berikutnya."
                    txtLabel2="Silahkan ambil Cup"
                    txtLabel3="Lalu tekan Cup Berikutnya"
                    #self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span>")
                    self.lblInformation2.setText("<span style='font-size:30pt'>"+txtLabel1+"</span><br><span style='font-size:50pt'>"+txtLabel2+"</span><br><span style='font-size:50pt'>"+txtLabel3+"</span>")
                    #self.lblInformation2.setText("Sisa cup : "+ str(self.OrderQty)+". \nSilahkan ambil Cup lalu tekan Cup Berikutnya.")
                self.NextCupBtn.show()
            self.TimerStatus.stop()
        self.j+=1 
        
    def LaundroMatClicked(self):
        print("Laundromat")
        self.TrxId, urlqr = Api.CreatePayment(self.Staff, self.MenuSelected, self.OrderQty, "Laundromat")
        print("TrxId : "+self.TrxId + " , url : "+ urlqr)
        if self.TrxId != "Terjadi Kesalahan" and urlqr != "Terjadi Kesalahan":
            img=pyqrcode.create(self.TrxId)
            img.svg('qrcodelm.svg', scale=5)
            self.lblQR.setPixmap(QtGui.QPixmap("./qrcodelm.svg"))
            self.frameQR.show()
            self.i=0
            self.TimerPay.start()
    
    def WebView(self):
        self.webView.show()
            
    def AddQtyClicked(self):
        self.OrderQty=int(self.lblQty.text())
        if self.OrderQty<10 :
            self.OrderQty+=1
            self.lblQty.setText(str(self.OrderQty))
    
    def DecQtyClicked(self):
        self.OrderQty=int(self.lblQty.text())
        if self.OrderQty>1 :
            self.OrderQty-=1
            self.lblQty.setText(str(self.OrderQty))
        
    def CheckLog(self):
        print("Check Log :")
        if CheckFile(self.fileLogTrans) :
            with open(self.fileLogTrans, "r") as file:
                first_line = file.readline()
            #print(first_line[0:10])
            datelog=datetime.strptime(first_line[0:10], "%d/%m/%Y")
            datetoday=datetime.today()
            #print(datelog)
            #print(datetoday)
            diff=datetoday-datelog
            #print(diff.days)
            if diff.days>=1 :
                datelogs=first_line[0:10].replace("/", "-")
                target="/home/pi/Documents/OmegaSanitizer/LogTrans_"+datelogs+".txt"
                os.rename(self.fileLogTrans, target)
                print("berhasil di backup")
            else :
                print("belum perlu di backup")
                
    def retranslateUi(self, Dialog):
        _translate = QtCore.QCoreApplication.translate
        Dialog.setWindowTitle(_translate("Dialog", "Dialog"))
        Dialog.setWindowTitle(_translate("Dialog", "OmegaSanitizer"))
        if len(self.Caption1)>15 :
            self.Menu1Btn.setText(_translate("Dialog", self.Caption1[:15]+"..."))
        else :
            self.Menu1Btn.setText(_translate("Dialog", self.Caption1))
        if len(self.Caption2)>15 :
            self.Menu2Btn.setText(_translate("Dialog", self.Caption2[:15]+"..."))
        else :
            self.Menu2Btn.setText(_translate("Dialog", self.Caption2))
        if len(self.Caption3)>15 :
            self.Menu3Btn.setText(_translate("Dialog", self.Caption3[:15]+"..."))
        else :
            self.Menu3Btn.setText(_translate("Dialog", self.Caption3))
        self.lblUserID.setText(_translate("Dialog", "User"))
        self.lblPassword.setText(_translate("Dialog", "Password"))
        self.CancelLoginBtn.setText(_translate("Dialog", "Cancel"))
        self.LoginBtn.setText(_translate("Dialog", "Login"))
        self.lblStaff.setText(_translate("Dialog", "Staff"))
        self.lblSettingTime.setText(_translate("Dialog", "Setting Time"))
        self.lblMenu1.setText(_translate("Dialog", "Menu 1"))
        self.lblMenu2.setText(_translate("Dialog", "Menu 2"))
        self.lblMenu3.setText(_translate("Dialog", "Menu 3"))
        self.ResetIngredientBtn.setText(_translate("Dialog", "Ingredient"))
        self.CancelSaveBtn.setText(_translate("Dialog", "Cancel"))
        self.SaveBtn.setText(_translate("Dialog", "Save"))
        self.LaundroMatBtn.setText(_translate("Dialog", "Laundromat Pay"))
        self.GoPayBtn.setText(_translate("Dialog", "GoPay"))
        self.LinkAjaBtn.setText(_translate("Dialog", "LinkAja"))
        self.ShopeeBtn.setText(_translate("Dialog", "Shopee"))
        self.CancelPaymentBtn.setText(_translate("Dialog", "Cancel"))
        self.lblInformation.setText(_translate("Dialog", "Pembayaran Berhasil"))
        self.BackToMainBtn.setText(_translate("Dialog", "Kembali ke Menu Utama"))
        self.lblInformation2.setText(_translate("Dialog", "Sisa Cup : "))
        self.NextCupBtn.setText(_translate("Dialog", "Cup Berikutnya"))
        self.lblInfoProgress.setText(_translate("Dialog", "Harap tunggu..."))
        self.ProgressBackBtn.setText(_translate("Dialog", "Kembali"))
        self.lblMenuSelected.setText(_translate("Dialog", "Pilihan Rasa"))
        self.lblMenuPrice.setText(_translate("Dialog", "Rp ..."))
        self.lblStep.setText(_translate("Dialog", "Step - "))
        self.NextHelpBtn.setText(_translate("Dialog", "Next"))
        self.CancelSinglePaymentBtn.setText(_translate("Dialog", "Cancel"))
        self.CancelMultiPaymentBtn.setText(_translate("Dialog", "Cancel"))
        self.CancelPaymentBtn2.setText(_translate("Dialog", "Cancel"))
        self.AddQtyBtn.setText(_translate("Dialog", "+"))
        self.DecQtyBtn.setText(_translate("Dialog", "-"))
        self.lblQty.setText(_translate("Dialog", "1"))
        self.frameRefreshInfo.hide()


from PyQt5 import QtWebKitWidgets

if __name__ == "__main__":
    import sys
    #AutoUpdate.UpdateProgram()
    app = QtWidgets.QApplication(sys.argv)
    Dialog = QtWidgets.QDialog()
    ui = Ui_Dialog()
    ui.setupUi(Dialog)
    Dialog.show()
    sys.exit(app.exec_())

